/*********************************************************************
 *
 * DESCRIPTION:
 *      This file defines the file open action. It also defines the
 *      filter class used to select only supported graph files.
 *
 ********************************************************************/

package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.visualizer.AboutDialog;

import java.awt.Frame;
import java.awt.Label;
import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;

/**
 * Implements the About action used to open an about
 * Dialog
 * @author
 * @version
 */
public class AboutAction extends CreekAction {

    /**
     * Creates a new AboutAction object with the default action
     * command string of "about".
     */
    public AboutAction() {
        super( "about" );
    } // OpenAction

    /**
     * Performs the about action. This presents the user with
     * a about dialog
     *
     * @param  event  action event
     */
    public void actionPerformed( ActionEvent event ) {
        // get graph window that contains our invoker
        Frame win = getWindow( event );
        // display the about dialog
        AboutDialog about = new AboutDialog();

    } // actionPerformed

} // OpenAction
