package jcreek.cke.command;

import javax.swing.undo.UndoableEdit;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import jcreek.cke.conceptview.VisualRelation;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.RelationList;
import jcreek.cke.graph.CreekModel;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class ActivateRelationCommand extends CreekCommand {

    /**
     * Relation added to model.
     */
      VisualRelation addRelation;

//    protected RelationList relations;

  public ActivateRelationCommand(CreekDocument doc,VisualRelation vr) {
      super(doc);
//      relations = new RelationList();
//      relations.add(vr);
      addRelation = vr;
      canUndoRedo = true;
  }//ActivateRelationCommand


  public String getUndoPresentationName() {
    return "Undo Activate Relation";
  }

  public boolean perform() {
        if ( ( getDocument() != null ) && ( addRelation != null ) ) {
            CreekModel model = getDocument().getModel();
//            System.out.println("Trying to activate "+addRelation);
            return model.addRelation(addRelation);
//            return model.addRelationList( relations );
        } else {
            return false;
        }
  }//perform


  public void die() {
        canUndoRedo = false;
        addRelation = null;
  }

  public boolean isSignificant() {
    return true;
  }

  public void redo() throws javax.swing.undo.CannotRedoException {
        if ( ( canUndoRedo ) && ( addRelation != null ) ) {
            CreekModel model = getDocument().getModel();
            model.addRelation(addRelation);
        } else {
            throw new CannotRedoException();
        }
  }
  public void undo() throws javax.swing.undo.CannotUndoException {
        if ( ( canUndoRedo ) && ( addRelation != null ) ) {
            CreekModel model = getDocument().getModel();
            model.removeRelation(addRelation);
        } else {
            throw new CannotRedoException();
        }
  }

  public boolean addEdit(UndoableEdit parm1) {
	// For now we don't support merging.
        return false;
  }

  public String getRedoPresentationName() {
    return "Redo Activate Relation";
  }

  public boolean replaceEdit(UndoableEdit parm1) {
        // Assume that we can't for now.
        return false;
  }

  public String getPresentationName() {
    return "Activate Relation";
  }
}