package jcreek.cke.command;

import javax.swing.undo.UndoableEdit;

import jcreek.representation.Relation;
import jcreek.representation.Entity;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.conceptview.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class ChangeRelationCommand extends CreekCommand {

  Relation oldRelation;
  Relation newRelation;

  public ChangeRelationCommand(CreekDocument doc,
                      Relation oldRelation,
                      Relation newRelation)
  {
      super(doc);
      this.oldRelation = oldRelation;
      this.newRelation = newRelation;
      canUndoRedo = false;
  }


  public String getUndoPresentationName() {
    return "Undo Modify Relation";
  }

  public boolean perform() {
        if ( ( getDocument() != null )
                && ( oldRelation != null )
                && ( newRelation != null) )
        {
            CreekModel model = getDocument().getModel();
            VisualRelation oldVR = model.findVisualRelation(oldRelation);
            if(oldVR!=null)
            {
                model.removeRelation(oldRelation);
                VisualEntity veFrom = model.findVisualEntity(newRelation.getFrom());
                VisualEntity veTo   = model.findVisualEntity((Entity)newRelation.getValue());
                if((veTo!=null) && (veFrom!=null))
                {
                      VisualRelation vRel = new VisualRelation(veFrom,veTo,newRelation);
                      model.addRelation(vRel);
                }
                return true;
            }
            else
            {
              model.removeRelation(oldRelation);
              return true;
            }
        }
        else
        {
            return false;
        }
  }

  public void die() {
        canUndoRedo = false;
        oldRelation = null;
        newRelation = null;
  }

  public boolean isSignificant() {
    return true;
  }

  public void redo() throws javax.swing.undo.CannotRedoException {
  }

  public void undo() throws javax.swing.undo.CannotUndoException {
  }

  public boolean addEdit(UndoableEdit parm1) {
	// For now we don't support merging.
        return false;
  }

  public String getRedoPresentationName() {
    return "Redo  Modify Relation";
  }

  public boolean replaceEdit(UndoableEdit parm1) {
    return false;
  }

  public String getPresentationName() {
    return " Modify Relation";
  }

}