package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;

import java.awt.event.ActionEvent;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class CloseAction extends CreekAction  {


  /**
   * Creates a new CloseAction object with the default action
   * command string of "close".
   */
  public CloseAction() {
        super("close");

  }

  /**
   * Performs the close action. Basically just calls the
   * <code>saveFile()</code> method of the of SaveAction class.
   * This will force a file selector to be presented to the user.
   *
   * @param  event  action event
   */
  public void actionPerformed(ActionEvent event) {
        // get graph window that contains our invoker
        Visualizer win = (Visualizer)getWindow( event );
        // save the file, asking the user if they want to save or not
//        if ( saveFile( win, true, false ) ) {
            CreekDocumentGroup.instanceOf().closeDocument();
            win.closeWindow();
//        }
 }



}


