package jcreek.cke.command;

import javax.swing.undo.UndoableEdit;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */
import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.graph.VertexList;
import jcreek.cke.graph.RelationList;
import jcreek.cke.conceptview.*;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.util.Iterator;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

public class CutCommand extends CreekCommand {

    /**
     * Entity to be Deactivated.
     */
    protected VertexList remEntity;

    protected RelationList remRelation;

  public CutCommand(CreekDocument doc,VertexList ve) {
      super(doc);
      this.remEntity = ve;
      remRelation = new RelationList();
      for(int i=0;i<remEntity.size();i++)
      {
          Iterator iterator = remEntity.get(i).getEdgeIterator();
          VisualRelation vr;
          while(iterator.hasNext())
          {
              vr = (VisualRelation)iterator.next();
              remRelation.add(vr);
          }
      }
      canUndoRedo = true;
  }

  public String getUndoPresentationName() {
    return "Undo Cut Entity";
  }

  public boolean perform() {
        if ( ( getDocument() != null ) && ( remEntity != null ) ) {
            CreekModel model = getDocument().getModel();
            if(model.removeRelationList(remRelation))
                if(model.removeEntityList(remEntity))
                    return true;
                else
                    return false;
            else
                return false;
//            return model.removeEntityList(remEntity);
        } else {
            return false;
        }
  }

  public void die() {
        canUndoRedo = false;
        remEntity.clear();
        remEntity = null;
  }

  public boolean isSignificant() {
    return true;
  }

  public void redo() throws javax.swing.undo.CannotRedoException {
        if ( ( canUndoRedo ) && ( remEntity != null ) ) {
            CreekModel model = getDocument().getModel();
            model.removeRelationList(remRelation);
            model.removeEntityList(remEntity);
        } else {
            throw new CannotUndoException();
        }
  }

  public void undo() throws javax.swing.undo.CannotUndoException {
        if ( ( canUndoRedo ) && ( remEntity != null ) ) {
            CreekModel model = getDocument().getModel();
            model.addEntityList(remEntity);
            model.addRelationList(remRelation);
        } else {
            throw new CannotUndoException();
        }
  }

  public boolean addEdit(UndoableEdit parm1) {
	// For now we don't support merging.
        return false;
  }

  public String getRedoPresentationName() {
    return "Redo Cut Entity";
  }

  public boolean replaceEdit(UndoableEdit parm1) {
        // Assume that we can't for now.
        return false;
  }

  public String getPresentationName() {
    return "Cut Entity";
  }

}