package jcreek.cke.command;

import javax.swing.undo.UndoableEdit;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.graph.VertexList;
import jcreek.cke.conceptview.VisualEntity;

import jcreek.representation.RelationType;
import jcreek.representation.EntityTypeNotMatchedException;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

public class DeleteEntityCommand extends CreekCommand {

    /**
     * Entity to be Deactivated.
     */
    protected VertexList remEntity;

  public DeleteEntityCommand(CreekDocument doc,VertexList ve) {
      super(doc);
      this.remEntity = ve;
      canUndoRedo = false;
  }

  public String getUndoPresentationName() {
    return "Undo Delete Entity";
  }

  public boolean perform() {
        if ( ( getDocument() != null ) && ( remEntity != null ) ) {

            CreekModel model = getDocument().getModel();
            return model.deleteEntityList(remEntity);
        } else {
            return false;
        }
  }

  public void die() {
        canUndoRedo = false;
        remEntity.clear();
        remEntity = null;
  }

  public boolean isSignificant() {
    return true;
  }

  public void redo() throws javax.swing.undo.CannotRedoException {
  }

  public void undo() throws javax.swing.undo.CannotUndoException {
  }

  public boolean addEdit(UndoableEdit parm1) {
	// For now we don't support merging.
        return false;
  }

  public String getRedoPresentationName() {
    return "Redo Deactivate Entity";
  }

  public boolean replaceEdit(UndoableEdit parm1) {
    return false;
  }

  public String getPresentationName() {
    return "Deactivate Entity";
  }

}
