package jcreek.cke.command;

import javax.swing.undo.UndoableEdit;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */
import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.graph.RelationList;
import jcreek.cke.conceptview.VisualRelation;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

public class DeleteRelationCommand extends CreekCommand {

    /**
     * Entity to be Deactivated.
     */
    protected RelationList delRelation;

  public DeleteRelationCommand(CreekDocument doc,RelationList vr) {
      super(doc);
      this.delRelation = vr;
      canUndoRedo = false;
  }

  public String getUndoPresentationName() {
    return "Undo Delete Relation";
  }
  public boolean perform() {
        if ( ( getDocument() != null ) && ( delRelation != null ) ) {
            CreekModel model = getDocument().getModel();
            return model.deleteRelationList(delRelation);
        } else {
            return false;
        }
  }


  public void die() {
        canUndoRedo = false;
        delRelation.clear();
        delRelation = null;
  }


  public boolean isSignificant() {
    return true;
  }


  public void redo() throws javax.swing.undo.CannotRedoException {
  }

  public void undo() throws javax.swing.undo.CannotUndoException {
  }

  public boolean addEdit(UndoableEdit parm1) {
	// For now we don't support merging.
        return false;
  }

  public String getRedoPresentationName() {
    return "Redo Delete Entity";
  }

  public boolean replaceEdit(UndoableEdit parm1) {
    return false;
  }

  public String getPresentationName() {
    return "Delete Entity";
  }
}