package jcreek.cke.command;

import java.util.Vector;
import java.awt.event.ActionEvent;
import java.awt.Frame;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JOptionPane;
import javax.swing.JInternalFrame;
import java.awt.Component;
import java.awt.Rectangle;


import jcreek.cke.browser.Visualizer;
import jcreek.cke.visualizer.SubModelDialog;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.representation.Entity;
import jcreek.representation.Relation;
import jcreek.representation.RelationType;
import jcreek.cke.visualizer.FrameView;
import jcreek.cke.visualizer.PropertyControl;
import jcreek.cke.conceptview.*;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class EntityPropertiesAction extends CreekAction implements PropertyChangeListener{

  public EntityPropertiesAction() {
        super("entityProperty");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
        // first see if there is a current file and if it is dirty
        CreekDocument doc = getDocument();
        if ( doc == null ) {
            noCurrentDocument( win );
            return;
        }
        if(doc.getModel().getSelectedEntities().length>0)
          FrameView.createPermanentFrameView(doc.getModel().getSelectedEntities()[0].getEntity(), win);


//        displayFrameProperty(win);
  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "selection" ) ) {
            CreekDocument doc = (CreekDocument)e.getOldValue();
              if ( doc != null ) {
                      if(doc.getModel().getSelectedEntities().length>0)
                            setEnabled(true);
                      else
                            setEnabled(false);
              } else {
                      setEnabled( false );
              }
        }
  }
/*
  public static void displayFrameViewWindow(Entity entity)
  {
    JInternalFrame frame = new JInternalFrame(myCase.getName()+" "+getString("frameViewTitle"));
    FramePane pane = new FramePane(entity);
    pane.attach();
    pane.setEditable(true);
    frame.setContentPane(new JScrollPane(pane));
    frame.setSize(frame.getContentPane().getPreferredSize().width+10, 500);
    frame.setResizable(true);
    frame.setIconifiable(false);
    frame.setClosable(true);
    win.registerWindow(frame);
    frame.setVisible(true);
    frame.addInternalFrameListener(new InternalFrameAdapter() {
      public void internalFrameClosed(InternalFrameEvent e)
      {
        ((FramePane) ((JViewport) e.getInternalFrame().getContentPane().getComponent(0)).getView()).detach();
      }
    });

  }
*/

    public void displayFrameProperty(Visualizer win)
    {
/*
        PropertyControl pc = win.getPropertyControl();
        VisualEntity[] vEntities = getModel().getSelectedEntities();
        pc.displayProperty(vEntities[0].getEntity());
*/
        VisualEntity[] vEntities = getModel().getSelectedEntities();
        win.displayPropertyWindow(vEntities[0].getEntity());




    }//displayFrameProperty

}