package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.MainWindow;
import jcreek.cke.visualizer.ModelPropertyDlg;
import jcreek.representation.KnowledgeModel;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.awt.FileDialog;
import javax.swing.JOptionPane;
import java.awt.Component;
import java.awt.Rectangle;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class ModelPropertyAction extends CreekAction implements PropertyChangeListener
{

  public ModelPropertyAction() {
        super("modelProperty");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }
  public void actionPerformed(ActionEvent event) {
        displayModelDlg( getWindow( event ));
  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "opened" ) )
        {
            if(e.getNewValue()==null)
                  setEnabled(false);
            else
                  setEnabled(true);
        }
        else if(e.getPropertyName().equals( "closed" ))
            setEnabled(false);
  }

    public void displayModelDlg(Visualizer win)
    {
        CreekDocumentGroup dg = CreekDocumentGroup.instanceOf();
        ModelPropertyDlg newKMdg = new ModelPropertyDlg(win,
                                        getString("modelPropTitle"),
                                        ModelPropertyDlg.EDIT_MODE);
        if(newKMdg.isOK())
        {
                    KnowledgeModel km = dg.getKM();
                    km.setAuthor(newKMdg.getAuthor());
                    km.setName(newKMdg.getName());
                    km.setDescription(newKMdg.getDesc());
                    km.setAuthor(newKMdg.getAuthor());
                    win.setTitle(getString("AppTitle")
                      + " " +km.getName());

        }

    }//displaySubModel




}