package jcreek.cke.command;
/**
 * Title:        JavaCreek
 * Description:  A Case Based Reasoning approach developed in Java
 * Copyright:    Copyright (c) 1999
 * Company:      Phil Systems
 * @author Victor Dias
 * @version
 */

import java.awt.FileDialog;
import javax.swing.JOptionPane;
import java.awt.event.ActionEvent;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.conceptview.ConceptView;
import jcreek.cke.browser.Visualizer;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;


public class NewConceptViewAction extends CreekAction implements PropertyChangeListener
{

  public NewConceptViewAction()
  {
      super("newConceptView");
      setEnabled(false);
      CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

    /**
     * Performs the new action. This creates a new graph document
     * and a window to display it in.
     *
     * @param  event  action event
     */
    public void actionPerformed( ActionEvent event ) {
        Visualizer win = getWindow( event );
        // tell document group to make new document
        ConceptView view = win.newWindow( "new window" );
        CreekDocumentGroup docgroup = CreekDocumentGroup.instanceOf();
          if ( !docgroup.newDocument( view ) ) {
              // failed, close window we just created
              win.closeWindow();
              JOptionPane.showMessageDialog
                  ( win,
                    getString( "couldntCreateViewMsg" ),
                    getString( "operFailed"+ Visualizer.titleSuffix ),
                    JOptionPane.ERROR_MESSAGE );

          } else {
              // get document untitled name, set window title
              CreekDocument doc = docgroup.getCurrentDocument();
              win.renameWindow( doc.getTitle() );
          }
/*
              // save the file without special options
        saveFile( getWindow( event ), false, false );
*/
    } // actionPerformed

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "opened" ) )
        {
            if(e.getNewValue()==null)
                  setEnabled(false);
            else
                  setEnabled(true);
        }
        else if(e.getPropertyName().equals( "closed" ))
            setEnabled(false);
  }

  /*
    protected boolean saveFile( Visualizer win,
                                boolean askUser,
                                boolean forceSaveAs ) {
        boolean okay = true;
        // document isn't titled, ask user for a name
            FileDialog fd = new FileDialog
                ( win,
		  getString( "newViewTitle" ),
		  FileDialog.SAVE );
            fd.show();
            if ( ( fd.getFile() != null ) ||( fd.getDirectory() != null ) ) {
                ConceptView view = win.newWindow( "new window" );
                CreekDocumentGroup dg = CreekDocumentGroup.instanceOf();
                // tell document group to save as current file
                if ( ( okay = dg.newDocument( view, fd.getFile(), fd.getDirectory() ) ) ) {
                    CreekDocument doc = dg.getCurrentDocument();
                    win.renameWindow( doc.getTitle() );
                }
            }
                else
                {
                      win.closeWindow();
                      JOptionPane.showMessageDialog
                          ( win,
                            getString( "couldntCreateViewMsg" ),
                            getString( "operFailedTitle" ),
                            JOptionPane.ERROR_MESSAGE );
                }
        return okay;
    } // saveFile

*/

}//NewConceptViewAction