package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.graph.VertexList;
import jcreek.cke.visualizer.NewEntityDialog;
import jcreek.representation.Entity;
import jcreek.representation.NameAlreadyExistException;
import jcreek.cke.conceptview.VisualEntity;
import jcreek.cke.visualizer.FrameView;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JOptionPane;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class NewEntityAction extends CreekAction implements PropertyChangeListener {

  public NewEntityAction() {
        super("newEntity");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
         // first see if there is a current file and if it is dirty
        CreekDocumentGroup dg = CreekDocumentGroup.instanceOf();
        CreekDocument doc = dg.getCurrentDocument();
        if ( doc == null ) {
	    noCurrentDocument( win );
            return;
        }

        int i=0;
        String add = "";
        String name = "New Entity";
        while(dg.getKM().hasEntity(name+add))
        {
          i++;
          add = " ("+i+")";
        }

        try
        {
          Entity newEnt = new Entity(dg.getKM(),name,"");
          FrameView.createPermanentFrameView(newEnt, win);
        }
        catch(NameAlreadyExistException e)
        {
          e.printStackTrace();
        }
        /*
        CreekModel model = doc.getModel();
        NewEntityDialog newRel = new NewEntityDialog(win,
                      "New Entity "); */
  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "selection" ) ) {
            CreekDocument doc = (CreekDocument)e.getOldValue();
              if ( doc != null ) {
                      if(doc.getModel().getSelectedEntities().length>0 && CreekDocumentGroup.instanceOf().getKnowledgeModelEditable())
                            setEnabled(true);
                      else
                            setEnabled(false);
              } else {
                      setEnabled( false );
              }
        }
  }



}