package jcreek.cke.command;

import javax.swing.undo.UndoableEdit;
import java.awt.Point;

import jcreek.cke.conceptview.VisualEntity;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.util.DPoint;
import jcreek.representation.Entity;
import jcreek.representation.KnowledgeModel;
import jcreek.representation.NameAlreadyExistException;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class NewEntityCommand extends CreekCommand {

  protected Point loc;

  public NewEntityCommand(CreekDocument doc,Point loc) {
      super(doc);
      this.loc = loc;
      canUndoRedo = false;
  }

  public String getUndoPresentationName() {
    return "Undo New Entity";
  }

  public boolean perform() {

          int i = 0;
         String entName = "New Entity";
         KnowledgeModel km = CreekDocumentGroup.instanceOf().getKM();
          while(km.getEntity(entName) != null)
          {
              i++;
              entName = "New Entity ("+i+")";
          }
          try
          {
            Entity newEnt = new Entity(CreekDocumentGroup.instanceOf().getKM(),"New Entity"+(i==0?"":" ("+i+")"), "");
            if(newEnt!=null)
            {
              VisualEntity v = new VisualEntity(newEnt,loc.x,loc.y);

              DPoint pos = new DPoint(loc.x,loc.y);
              pos.transform(document.getView().getMoveTransform());
              v.setPosition(pos);

              ActivateEntityCommand action = new ActivateEntityCommand( document, v );
              if(document.performCommand( action ))
              {
                document.getModel().unselectAllVertices();
                document.getModel().setSelected(v,true);
                return true;
              }
            }
          }
          catch(NameAlreadyExistException e)
          {
            e.printStackTrace();
          }
          return false;

  }

  public void die() {
        canUndoRedo = false;
        loc = null;
  }

  public boolean isSignificant() {
        return true;
  }

  public void redo() throws javax.swing.undo.CannotRedoException {
  }

  public void undo() throws javax.swing.undo.CannotUndoException {
  }

  public boolean addEdit(UndoableEdit parm1) {
	// For now we don't support merging.
        return false;
  }

  public String getRedoPresentationName() {
    return "Redo New Entity";
  }

  public boolean replaceEdit(UndoableEdit parm1) {
        // Assume that we can't for now.
        return false;
  }

  public String getPresentationName() {
    return "New Entity";
  }

}