package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.graph.VertexList;
import jcreek.cke.visualizer.NewRelationDialog;
import jcreek.representation.Entity;
import jcreek.cke.conceptview.VisualEntity;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JOptionPane;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class NewRelationAction extends CreekAction implements PropertyChangeListener {

  public NewRelationAction() {
        super("newRelation");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
         // first see if there is a current file and if it is dirty
        CreekDocumentGroup dg = CreekDocumentGroup.instanceOf();
        CreekDocument doc = dg.getCurrentDocument();
        if ( doc == null ) {
	    noCurrentDocument( win );
            return;
        }
        CreekModel model = doc.getModel();
        VisualEntity[] selEntities = model.getSelectedEntities();
        Entity selEntity;
        if(selEntities.length==0)
          selEntity = null;
        else
          selEntity = selEntities[0].getEntity();
        if(selEntity!=null)
        {
          NewRelationDialog newRel = new NewRelationDialog(win,
                      "New Relation For "+selEntity.getName(),
                      selEntity);
        }


  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "selection" ) ) {
            CreekDocument doc = (CreekDocument)e.getOldValue();
              if ( doc != null ) {
                      if(doc.getModel().getSelectedEntities().length>0)
                            setEnabled(true);
                      else
                            setEnabled(false);
              } else {
                      setEnabled( false );
              }
        }
  }

}