package jcreek.cke.command;


import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.ActionEvent;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;

import jcreek.cke.browser.Visualizer;

import jcreek.cke.document.CreekDocument;

import jcreek.representation.cbr.Case;
import jcreek.gui.reasoning.*;
import jcreek.reasoning.*;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Frode Srmo
 * @version 1.0
 */

public class OpenCaseMatchAction extends CreekAction implements PropertyChangeListener
{
  public OpenCaseMatchAction()
  {
    super("openCaseMatch");
    setEnabled( false );
    // we want to be notified of changes in the documents
    CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
    Visualizer win = getWindow( event );
    // first see if there is a current file and if it is dirty
    CreekDocument doc = getDocument();
    if(doc.getModel().getSelectedEntities().length > 0 && Case.matches(doc.getModel().getSelectedEntities()[0].getEntity()))
    {
      try
      {
        Case myCase = (Case) new Case(doc.getModel().getSelectedEntities()[0].getEntity());
        JInternalFrame frame = new JInternalFrame(myCase.getName()+" "+getString("caseMatchTitle"));
        RetrieveResult retrieve = new RetrieveResult(myCase, false);
        RetrieveResultPane retrievePane = new RetrieveResultPane(retrieve);
        retrievePane.attach();
        ReuseResult reuse = new ReuseResult(retrieve, 5, false);
        ReuseResultPane reusePane = new ReuseResultPane(reuse);
        reusePane.attach();

        JTabbedPane tabs = new JTabbedPane();
        tabs.addTab(getString("caseMatchRetrieveTab"), retrievePane);
        tabs.addTab(getString("caseMatchReuseTab"), reusePane);


      //      pane.setEditable(true);
        frame.setContentPane(tabs);
        frame.setSize(tabs.getPreferredSize().width+20, tabs.getPreferredSize().height+100);
        frame.setResizable(true);
        frame.setIconifiable(false);
        frame.setClosable(true);
        win.registerWindow(frame);
        frame.setVisible(true);
        frame.addInternalFrameListener(new DetachComponents(retrievePane, reusePane));
      }
      catch(jcreek.util.CreekException e)
      {
        e.printStackTrace();
      }
    }
  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "selection" ) ) {
            CreekDocument doc = (CreekDocument)e.getOldValue();
              if ( doc != null ) {
                      if(doc.getModel().getSelectedEntities().length > 0 && Case.matches(doc.getModel().getSelectedEntities()[0].getEntity()))
                            setEnabled(true);
                      else
                            setEnabled(false);
              } else {
                      setEnabled( false );
              }
        }
  }

  class DetachComponents extends InternalFrameAdapter
  {
    RetrieveResultPane retrievePane;
    ReuseResultPane reusePane;

    DetachComponents(RetrieveResultPane retrievePane, ReuseResultPane reusePane)
    {
      this.retrievePane = retrievePane;
      this.reusePane = reusePane;
    }

    public void internalFrameClosed(InternalFrameEvent e)
    {
      retrievePane.detach();
      reusePane.detach();
    }
  }
}
