package jcreek.cke.command;

import java.awt.FileDialog;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.ActionEvent;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.visualizer.CaseView;
import jcreek.cke.browser.Visualizer;
import jcreek.cke.graph.VertexList;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.MainWindow;
import jcreek.cke.util.SelectionSet;
import jcreek.representation.cbr.Case;
import jcreek.gui.representation.CasePane;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Frode Srmo
 * @version 1.0
 */

public class OpenCaseViewAction extends CreekAction implements PropertyChangeListener
{
  public OpenCaseViewAction()
  {
    super("openCaseView");
    setEnabled( false );
    // we want to be notified of changes in the documents
    CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
    Visualizer win = getWindow( event );
    // first see if there is a current file and if it is dirty
    CreekDocument doc = getDocument();
    if(doc.getModel().getSelectedEntities().length > 0 && Case.matches(doc.getModel().getSelectedEntities()[0].getEntity()))
    {
      try
      {
        Case myCase = (Case) new Case(doc.getModel().getSelectedEntities()[0].getEntity());
        new CaseView(win, myCase);
      }
      catch(jcreek.util.CreekException e)
      {
        e.printStackTrace();
      }
    }
  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "selection" ) ) {
            CreekDocument doc = (CreekDocument)e.getOldValue();
              if ( doc != null ) {
                      if(doc.getModel().getSelectedEntities().length > 0 && Case.matches(doc.getModel().getSelectedEntities()[0].getEntity()))
                            setEnabled(true);
                      else
                            setEnabled(false);
              } else {
                      setEnabled( false );
              }
        }
  }
}
