package jcreek.cke.command;


import javax.swing.JOptionPane;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JOptionPane;

import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.conceptview.ConceptView;
import jcreek.cke.browser.Visualizer;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class OpenConceptViewAction extends CreekAction implements PropertyChangeListener{


  public OpenConceptViewAction() {
      super("openConceptView");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
        CreekDocument doc = (CreekDocument)getValue("selDoc" );
        if ( doc == null ) {
	    noCurrentDocument( win );
            return;
        }
        // tell document group to make new document
        ConceptView view = win.newWindow( "new window" );
        CreekDocumentGroup docgroup = CreekDocumentGroup.instanceOf();
          if ( !docgroup.openDocument( view,doc) ) {
              // failed, close window we just created
              win.closeWindow();
              putValue("selDoc",null);
          } else {
              // get document untitled name, set window title
              CreekDocument cdoc = docgroup.getCurrentDocument();
              win.renameWindow( cdoc.getTitle() );
              putValue("selDoc",null);
          }
  }

    public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "opened" ) )
        {
            if(e.getNewValue()==null)
                  setEnabled(false);
            else
                  setEnabled(true);
        }
        else if(e.getPropertyName().equals( "closed" ))
            setEnabled(false);

    }


}



