package jcreek.cke.command;

import java.awt.datatransfer.*;
import java.awt.Toolkit;
import java.awt.Point;
import java.awt.Component;
import java.awt.event.ActionEvent;
import javax.swing.*;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */
import java.awt.FileDialog;
import javax.swing.JOptionPane;
import java.awt.event.ActionEvent;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.conceptview.ConceptView;
import jcreek.cke.browser.Visualizer;
import jcreek.cke.graph.VertexList;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.MainWindow;
import jcreek.cke.util.SelectionSet;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

public class OpenEntityViewAction extends CreekAction implements PropertyChangeListener {

  public final DataFlavor dataFlavor =
          new DataFlavor(SelectionSet.class,"Array of VisualEntities");

  public OpenEntityViewAction() {
      super("openEntity");
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
         // first see if there is a current file and if it is dirty
        CreekDocument doc = getDocument();
        if ( doc == null ) {
	    noCurrentDocument( win );
            return;
        }
        CreekModel model = getModel();
        Action a = MainWindow.instanceOf().getAction( "copy" );
        a.actionPerformed( new ActionEvent
                           ( (Component)event.getSource(),
                             ActionEvent.ACTION_PERFORMED,
                             "copy" ) );
//        VertexList vl =new VertexList(model.getSelectedEntities());
        // tell document group to make new document
        ConceptView view = win.newWindow( "new window" );
        CreekDocumentGroup docgroup = CreekDocumentGroup.instanceOf();

          if ( !docgroup.newDocument( view ) ) {
              // failed, close window we just created
              win.closeWindow();
              JOptionPane.showMessageDialog
                  ( win,
                    getString( "couldntCreateViewMsg" ),
                    getString( "operFailedTitle" ),
                    JOptionPane.ERROR_MESSAGE );

          } else {
              // get document untitled name, set window title
              doc = docgroup.getCurrentDocument();
              win.renameWindow( doc.getTitle() );
/*
             a = MainWindow.instanceOf().getAction( "paste" );
             a.actionPerformed( new ActionEvent
                               ( (Component)doc.getView(),
                                 ActionEvent.ACTION_PERFORMED,
                                 "paste" ) );
*/
      Clipboard c = Toolkit.getDefaultToolkit().getSystemClipboard();
      Transferable t = c.getContents(this);
      if(t == null)
      {
        Toolkit.getDefaultToolkit().beep();
        return;
      }

      try
      {
/*
          //ask for clipboard contents to be converted to our dataflavor
          VertexList vl = (VertexList)t.getTransferData(dataFlavor);
          PasteCommand pc = new PasteCommand(getDocument(),vl,loc);
          if(!getDocument().performCommand(pc))
            throw new Exception();
*/
          SelectionSet s = (SelectionSet)t.getTransferData(dataFlavor);
          PasteCommand pc = new PasteCommand(getDocument(),s.getVertexList(),
                            s.getRelationList(),new Point(0,0));
          if(!getDocument().performCommand(pc))
            throw new Exception();

      }
      catch(UnsupportedFlavorException e)
      {
          Toolkit.getDefaultToolkit().beep();
          e.printStackTrace();
      }
      catch(Exception e)
      {
          Toolkit.getDefaultToolkit().beep();
          e.printStackTrace();
      }

          }

//        saveFile( getWindow( event ), false, false );

  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "selection" ) ) {
            CreekDocument doc = (CreekDocument)e.getOldValue();
              if ( doc != null ) {
                      if(doc.getModel().getSelectedEntities().length>0)
                            setEnabled(true);
                      else
                            setEnabled(false);
              } else {
                      setEnabled( false );
              }
        }
  }
/*
    protected boolean saveFile( Visualizer win,
                                boolean askUser,
                                boolean forceSaveAs ) {
        boolean okay = true;
        // document isn't titled, ask user for a name
            FileDialog fd = new FileDialog
                ( win,
		  getString( "newViewTitle" ),
		  FileDialog.SAVE );
            fd.show();
            if ( ( fd.getFile() != null ) ||( fd.getDirectory() != null ) ) {
                    CreekModel model = getModel();
                    VertexList vl =new VertexList(model.getSelectedEntities());
                    // tell document group to make new document
                    ConceptView view = win.newWindow( "new window" );
                    CreekDocumentGroup docgroup = CreekDocumentGroup.instanceOf();
                // tell document group to save as current file
                if ( ( okay = docgroup.newDocument( view, fd.getFile(), fd.getDirectory() ) ) ) {
                        // get document untitled name, set window title
                        CreekDocument doc = docgroup.getCurrentDocument();
                        win.renameWindow( doc.getTitle() );
                        doc.getModel().addEntityList(vl.copy());
                }
            }
                else
                {
                      win.closeWindow();
                      JOptionPane.showMessageDialog
                          ( win,
                            getString( "couldntCreateViewMsg" ),
                            getString( "operFailedTitle" ),
                            JOptionPane.ERROR_MESSAGE );
                }
        return okay;
    } // saveFile

*/
}