package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;

import java.util.Vector;
import java.awt.event.ActionEvent;
import java.awt.Frame;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JOptionPane;


public class OverviewAction extends CreekAction implements PropertyChangeListener {


  public OverviewAction() {
        super("overview");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );

  }


  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
        // first see if there is a current file and if it is dirty
        CreekDocument doc = getDocument();
        if ( doc == null ) {
	    noCurrentDocument( win );
            return;
        }
        CreekModel model = doc.getModel();
        if(model != null)
        {
            if((model.getSelectedEntities()).length <=0)
            {
                  JOptionPane.showMessageDialog
                      ( win,
                        getString( "noCurSelMsg" ),
                        getString( "usrErrorTitle" ),
                        JOptionPane.ERROR_MESSAGE );
                  return;
            }
        }
        else
          return;

        OverviewCommand ov = new OverviewCommand(doc);
        if(!doc.performCommand(ov))
            JOptionPane.showMessageDialog
                ( win,
		  getString( "invalidKMMsg" ),
                  getString( "operFailedTitle" ),
                  JOptionPane.ERROR_MESSAGE );


  }

    public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "opened" ) )
        {
            if(e.getNewValue()==null)
                  setEnabled(false);
            else
                  setEnabled(true);
        }
        else if(e.getPropertyName().equals( "closed" ))
            setEnabled(false);
    }



}


