package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.graph.VertexList;
//import jcreek.cke.preview.PreviewFrame;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import javax.swing.JFrame;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class PrintPreviewAction extends CreekAction implements PropertyChangeListener {



  public PrintPreviewAction() {
        super("printPreview");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
         // first see if there is a current file and if it is dirty
        CreekDocumentGroup dg = CreekDocumentGroup.instanceOf();
        CreekDocument doc = dg.getCurrentDocument();
        if ( doc == null ) {
	    noCurrentDocument( win );
            return;
        }
        attemptPreview(doc);

  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "selection" ) ) {
            CreekDocument doc = (CreekDocument)e.getOldValue();
              if ( doc != null ) {
                  setEnabled(true);
              } else {
                  setEnabled( false );
              }
        }
  }


  public void attemptPreview(CreekDocument doc)
  {
/*
      JFrame frame1 = new PreviewFrame (doc);
      frame1.pack ();
      frame1.show ();
      frame1.requestFocus ();
*/

  }

}