/*********************************************************************
 *
 * DESCRIPTION:
 *      This file defines the file revert action.
 *
 ********************************************************************/

package jcreek.cke.command;

import jcreek.cke.document.CreekDocument;

import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;

/**
 * Implements the revert file action used to discard changes made
 * to a graph document.
 *
 * @author
 * @version
 */

public class RevertAction extends CreekAction
{
    /**
     * Creates a new RevertAction object with the default action
     * command string of "revert".
     */
    public RevertAction() {
        super( "revert" );
    } // RevertAction

    /**
     * Performs the revert action. This asks the current document
     * to discard any changes that have been made. Possibly
     * displays an error dialog if the revert fails.
     *
     * @param  event  action event
     */
    public void actionPerformed( ActionEvent event ) {
    } // actionPerformed

}//RevertAction