package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.graph.VertexList;
import jcreek.cke.tool.CreekTool;
import jcreek.cke.conceptview.VisualEntity;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class SelectAction extends CreekAction implements PropertyChangeListener {

  public SelectAction() {
        super("select");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }
  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
         // first see if there is a current file and if it is dirty
        CreekDocument doc = getDocument();
        if ( doc == null ) {
	    noCurrentDocument( win );
            return;
        }
        CreekModel model = getModel();
        CreekTool tool = win.getCurrentTool();
        model.selectVertices(true ,model.getEntities());
        VertexList list = tool.getSelected();
        VisualEntity[] selList = model.getSelectedEntities();
        list.clear();
        for(int i=0;i<selList.length;i++)
            list.add(selList[i]);

        doc.getView().repaint();
        setEnabled(true);
  }

  public void propertyChange( PropertyChangeEvent e ) {
          setEnabled(true);
  }

}


