package jcreek.cke.command;

import java.awt.event.ActionEvent;
import java.awt.Component;
import java.awt.Frame;
import java.awt.Rectangle;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.visualizer.PreferencesDialog;
import jcreek.representation.KnowledgeModel;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;


/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class UserPrefsAction extends CreekAction implements PropertyChangeListener {

  PreferencesDialog diag;

  public UserPrefsAction() {
      super("prefs");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }
  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
        KnowledgeModel km = CreekDocumentGroup.instanceOf().getKM();
        if(km != null)
        {
          if(diag == null)
          {
              diag = new PreferencesDialog(win,km);
              centerComponent(diag,win);
          }
          diag.setVisible(true);
        }

  }

  private void centerComponent( Component c ,Frame mainFrame) {
        Rectangle winBounds = mainFrame.getBounds();
        Rectangle cBounds = c.getBounds();
        c.setLocation( ( winBounds.width - cBounds.width ) / 2 +
                       winBounds.x,
                       ( winBounds.height - cBounds.height ) / 2 +
                       winBounds.y );
    } // centerComponent

    public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "opened" ) )
        {
            if(e.getNewValue()==null)
                  setEnabled(false);
            else
                  setEnabled(true);
        }
        else if(e.getPropertyName().equals( "closed" ))
            setEnabled(false);
    }

}


