package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.importexport.*;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.MainWindow;
import jcreek.cke.document.CreekDocument;
import jcreek.representation.KnowledgeModel;
import jcreek.representation.LocalKnowledgeModel;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * <p>Title: Exports the current knowledgemodel to XML.</p>
 * <p>Description: </p>
 * @author Frode Srmo
 * @version 1.0
 */

public class XmlImportAction extends CreekAction implements PropertyChangeListener
{
  public XmlImportAction()
  {
    super("importModel");
    // we start life disabled, until a document is opened
    // and made dirty (which we'll know about by being a
    // change listener for the document group
    setEnabled( true );
    // we want to be notified of changes in the documents
    CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  /**
   * Performs the save action.
   * @param  event  action event
   */
  public void actionPerformed(ActionEvent event)
  {
    KnowledgeModel km = new LocalKnowledgeModel();
    ImportExportsWizards impWiz = new ImportExportsWizards(getWindow(event), km, ImportExportsWizards.IMPORT);
    impWiz.show();
    System.out.println("Open done");
    CreekDocumentGroup.instanceOf().setKM(km);
  }//actionPerformed

public void propertyChange( PropertyChangeEvent e ) {
      if ( e.getPropertyName().equals( "opened" ) )
      {
          if(e.getNewValue()==null)
                setEnabled(true);
          else
                setEnabled(false);
      }
      else if(e.getPropertyName().equals( "closed" ))
          setEnabled(true);
  }
}