package jcreek.cke.command;

import jcreek.cke.document.CreekDocument;
import jcreek.cke.conceptview.ConceptView;


import java.awt.Point;
import javax.swing.undo.UndoableEdit;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class ZoomCommand extends CreekCommand {

  double scale = 1.0;
  double oldScale = 1.0;
  public ZoomCommand(CreekDocument doc,double newScale) {
      super(doc);
      oldScale = doc.getView().getScale();
      scale = newScale;
      canUndoRedo = true;
  }//ZoomCommand

  public String getUndoPresentationName() {
    return "Undo Zoom";
  }

  public boolean perform() {
        if ( ( getDocument() != null ) ) {
            ConceptView view = getDocument().getView();
            view.setScale(scale);
            return true;
        } else {
            return false;
        }
  }

  public void die() {
        canUndoRedo = false;
        scale = 1.0;
  }

  public boolean isSignificant() {
        return true;
  }

  public void redo() throws javax.swing.undo.CannotRedoException {
        if ( ( canUndoRedo ) ) {
            ConceptView view = getDocument().getView();
            view.setScale(scale);
        } else {
            throw new CannotUndoException();
        }
  }

  public void undo() throws javax.swing.undo.CannotUndoException {
        if ( ( canUndoRedo ) ) {
            ConceptView view = getDocument().getView();
            view.setScale(oldScale);
        } else {
            throw new CannotUndoException();
        }
  }


  public boolean addEdit(UndoableEdit parm1) {
	// For now we don't support merging.
        return false;
  }

  public String getRedoPresentationName() {
    return "Redo Zoom";
  }

  public boolean replaceEdit(UndoableEdit parm1) {
        // Assume that we can't for now.
        return false;
  }

  public String getPresentationName() {
    return "Zoom View";
  }

}//ZoomCommand


