package jcreek.cke.command;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;



import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.browser.Visualizer;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.graph.CreekModel;
import jcreek.cke.conceptview.ConceptView;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class ZoomOutAction extends CreekAction implements PropertyChangeListener {

  public ZoomOutAction() {
        super("zoomOut");
        // we start life disabled, until a document is opened
        // and made dirty (which we'll know about by being a
        // change listener for the document group
        setEnabled( false );
        // we want to be notified of changes in the documents
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
  }

  public void actionPerformed(ActionEvent event) {
        Visualizer win = getWindow( event );
        // first see if there is a current file and if it is dirty
        CreekDocument doc = getDocument();
        if ( doc == null ) {
	    noCurrentDocument( win );
            return;
        }
        ConceptView view = doc.getView();
        double scale = 1.0;
        scale = view.getScale();
        scale -= 0.25;
        if(scale<0.25)
            scale = 0.25;
//        ((ZoomProperty)propWin).setScale((int)(scale*100.0));
      ZoomCommand zoomCmnd = new ZoomCommand(doc,scale);
      doc.performCommand(zoomCmnd);
  }

  public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "opened" ) )
        {
            if(e.getNewValue()==null)
                  setEnabled(false);
            else
                  setEnabled(true);
        }
        else if(e.getPropertyName().equals( "closed" ))
            setEnabled(false);
  }

}