package jcreek.cke.conceptview;

import java.io.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.JLabel;
import java.awt.Point;
import java.awt.geom.QuadCurve2D;
import java.awt.geom.AffineTransform;
import java.lang.Math;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import jcreek.representation.Relation;
import jcreek.representation.Entity;
import jcreek.cke.visualizer.AppSettings;


import jcreek.cke.util.Matrix33;
import jcreek.cke.util.DPoint;
import jcreek.cke.graph.Node;
import jcreek.cke.graph.Edge;

import jcreek.cke.CreekDocumentGroup;

public class VisualRelation implements Edge
{


  public VisualEntity       from;
  public VisualEntity       to;
  private Object           relationID;

  public boolean	selected = false;

  private boolean dummy_ = false;
  protected DPoint[] points_;


//  protected boolean drawRelNames;
//  protected Color relColor;


    protected double scale_=1.0;
    protected Font relationFont = new Font("Arial",Font.PLAIN,(int) Math.round(14*scale_));

  private static final long serialVersionUID=5376994504542361648L;

     /**
   * A general purpose data field.
   * Algorithms that operate on VisualRelations can store any necessary data here.
   **/
      private Object	data;


  public VisualRelation(VisualEntity from, VisualEntity to, Relation r)
  {
//    System.out.println("Creating new VisualRelation "+from+" - "+to+" - "+r);
      points_ = new DPoint[0];
      this.from = from;
//      this.from.addRelation(this);
      this.to = to;
//      this.to.addRelation(this);
      relationID = r.getID();
//      AppSettings.instanceOf().addChangeListener( this );
  }



  public boolean represents(Relation r)
  {
    return r.getID().equals(relationID);
  }
  public VisualEntity getTo()
  {
    return to;
  }

  public VisualEntity getFrom()
  {
    return from;
  }

  public Node getHead()
  {
      return from;
  }


  public Node getTail()
  {
      return to;
  }
/*
  public void stateChanged( ChangeEvent e )
  {
        AppSettings s = (AppSettings)e.getSource();
        // Get the new settings from the changed object.

        drawRelNames = s.getBoolean( AppSettings.RELATION_NAME );

        AppSettings.instanceOf().getR

        relColor=new Color(AppSettings.instanceOf().getRelation(getRelation().getRelationType().getName()));
  }

*/
/**
 * These methods are needed to convert Visual Relation
 * to Edge for the Graph
 **/


      public Object clone() throws java.lang.CloneNotSupportedException
      {
         VisualRelation copy;

         copy = (VisualRelation)super.clone();


         return copy;
      } //clone

      public void draw(Graphics2D graphics, Matrix33 transform)
      {
        draw(graphics, transform, transform.scale);
      }

      public void draw(Graphics2D graphics,  Matrix33 transform, double currentScale)
      {
//        System.out.println("Draw Relation");
//         Graphics2D graphics = (Graphics2D)g;
         Color defColor = graphics.getColor();

//         double currentScale = transform.scale;
         Color relColor = new Color(AppSettings.instanceOf().getRelation(getRelation().getRelationType().getName()));
         graphics.setColor(relColor);
         if(scale_ != currentScale)
         {
             scale_ = currentScale;
             relationFont = new Font("Arial",Font.PLAIN,(int) Math.round(14*scale_));
         }
         graphics.setFont(relationFont);

         int cnt = 1; //from.getRelationCount(to,this);
         QuadCurve2D.Double curve=new QuadCurve2D.Double();

         DPoint p1to, p2to;
            p1to = from.getPosition();
            p2to = to.getPosition();


         DPoint p1 = to.intersectWithLineTo(p1to);
         DPoint p2 = from.intersectWithLineTo(p2to);
          DPoint textPoint = new DPoint();
          if(p2.x < p1.x)
          {
            textPoint.x = (int) Math.round(((double) (p2.x*2+p1.x))/3.0);
            textPoint.y = (int) Math.round(((double) (p2.y*2+p1.y))/3.0);
          }
          else
          {
            textPoint.x = (int) Math.round(((double) (p2.x+p1.x*2))/3.0);
            textPoint.y = (int) Math.round(((double) (p2.y+p1.y*2))/3.0);
          }

          double dX = p1.x - p2.x;
          double dY = p1.y - p2.y;

          if(dX==0 && dY==0)
              return;//when the points are one and the same

          double vinkel;
            if(dX==0&&dY>0)
            vinkel= Math.PI/2;
          else if(dX==0&&dY<0)
            vinkel=Math.PI*3/2;
          else
            vinkel=Math.atan(dY/dX);

            DPoint ctrl =getCtrlPoint(p2,p1,cnt);
            if(transform != null)
            {
            ctrl.transform(transform);

            p1.transform(transform);
            p2.transform(transform);
            }
            graphics.setColor(relColor);
         if(cnt <= 1)
         {
           graphics.drawLine((int)p2.x, (int)p2.y,(int)p1.x, (int)p1.y);
      // Draw arrow.
            DPoint pfrom = new DPoint(p1to);
            if(transform != null)
              pfrom.transform(transform);
            if((int)pfrom.x == (int)p1.x && (int)pfrom.y == (int)p1.y)
               pfrom.x -= 10.0;

            drawArrow_(graphics, pfrom, p1);
         }
        else
        {

            curve.setCurve((int) Math.round(p2.x),(int) Math.round(p2.y),(int) Math.round(ctrl.x),(int) Math.round(ctrl.y),(int) Math.round(p1.x),(int) Math.round(p1.y));
            graphics.draw(curve);

        }
      // Draw Label

      String text = getRelation().getName();
      if(transform != null)
        textPoint.transform(transform);
/*
      graphics.rotate(-vinkel+0.08, textPoint.x, textPoint.y);  //rotate axis
      if(drawRelNames)
        graphics.drawString(text, (int)textPoint.x,(int) textPoint.y-1);  //draw text
      graphics.rotate(vinkel-0.08, textPoint.x, textPoint.y);
*/

      AffineTransform rat  =  AffineTransform.getRotateInstance(
                              vinkel);
      Font drwFont = relationFont.deriveFont(rat);
      Font iFont = graphics.getFont();
      graphics.setFont(drwFont);
      FontMetrics fm = graphics.getFontMetrics();
      int ascent = fm.getAscent();
      if(AppSettings.instanceOf().getBoolean( AppSettings.RELATION_NAME))
        graphics.drawString(text, (int)textPoint.x,(int) textPoint.y+ascent);  //draw text
      graphics.setFont(iFont);
      graphics.setColor(defColor);

      }//draw



      private DPoint getCtrlPoint(DPoint fromPos,DPoint toPos,int cnt)
      {
          DPoint ctrl=new DPoint();//control point to draw the curve

          ctrl.move(150*Math.cos(Math.toRadians(45+2*cnt))+fromPos.x,
                           150*Math.sin(Math.toDegrees(45+2*cnt ))+fromPos.y);

          if(fromPos.x > toPos.x)
          {
                ctrl.move(150*Math.cos(Math.toRadians(45+2*cnt))+toPos.x,
                150*Math.sin(Math.toDegrees(45+2*cnt ))+toPos.y);//when rotated it must becomes exactly how it was on the opp quadrant


          }

          return ctrl;
      }


      private void drawArrow_(Graphics2D graphics, DPoint p1, DPoint p2)
      {
         double dx = p1.x - p2.x;
         double dy = p1.y - p2.y;

         double length = Math.sqrt(dx * dx + dy * dy);

         DPoint p3 = new DPoint(p2.x, p2.y);

         double arrow_size = 6;

      	// Move 5 pixels back.
         p3.x += (arrow_size*scale_) / length * dx;
         p3.y += (arrow_size*scale_) / length * dy;

         DPoint p4 = new DPoint(p3.x, p3.y);

      	// Out 4 pixels.
         p4.x += (arrow_size*scale_) * .7 / length * dy;
         p4.y -= (arrow_size*scale_) * .7 / length * dx;

         p3.x -= (arrow_size*scale_) * .7 / length * dy;
         p3.y += (arrow_size*scale_) * .7 / length * dx;

         graphics.drawLine((int)p2.x, (int)p2.y, (int)p4.x, (int)p4.y);
         graphics.drawLine((int)p2.x, (int)p2.y, (int)p3.x, (int)p3.y);
      }//drawArrow

      public void setSelected(boolean selected)
      {
         this.selected = selected;
      }

      public boolean isSelected()
      {
          return selected;
      }


      public void remove()
      {
//          AppSettings.instanceOf().removeChangeListener(this);

      }

      public Relation getRelation()
      {
        return CreekDocumentGroup.instanceOf().getKM().getRelation(relationID);
      }

      public int hashCode()
      {
        return 7+getRelation().hashCode();
      }

      public boolean equals(Object ob)
      {
        if(ob instanceof VisualRelation)
          return ((VisualRelation) ob).getRelation().equals(getRelation());
        else
          return false;
        }
        public String toString()
        {
          return "VisualRelation for "+getRelation();
    }
}


