/*********************************************************************
 *
 *
 * DESCRIPTION:
 *      This file defines the class that handles reading and writing
 *      the Graph data Structure.
 *      See the class description below for more information.
 *
 ********************************************************************/

package jcreek.cke.document;

import jcreek.cke.graph.Graph;
import jcreek.cke.conceptview.*;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.IOException;

/**
 * Implements the CreekFormat interface to support Serialization
 *
 * @author
 * @version
 */
public class SerializeFormat implements CreekFormat
{


    public boolean read(FileInputStream fis,Graph grp,StringBuffer title)
    {

        ObjectInputStream input = null;
        try {
              input = new ObjectInputStream(fis);
              String name = (String)input.readObject();
              title = title.append(name.toCharArray());
              grp.copy((Graph)input.readObject());
          } catch ( IOException ioe ) {
            return false;
          }
          catch(ClassNotFoundException ce)
          {
              return false;
          }

        return true;
    }

    /**
     * Writes the Knowledge Model and the graph
     * to the given output stream.
     * @param  os  output stream to write to
     * @return  true if successful, false if error
     */
    public boolean write( FileOutputStream fos,Graph graph,String title)
    {

        ObjectOutputStream out = null;
        try {
            out = new ObjectOutputStream(fos);
            out.writeObject(title);
             VisualEntity tmpnode;
              out.writeObject(graph);
          } catch ( IOException ioe ) {
              ioe.printStackTrace();
            return false;
        }

        return true;
    }

}// SerializeFormat



