
package jcreek.cke.graph;

import java.beans.PropertyChangeListener;

import jcreek.cke.conceptview.*;
import jcreek.representation.Entity;
import jcreek.cke.util.Matrix33;
import jcreek.cke.graph.RelationList;
import jcreek.representation.RelationType;
import jcreek.representation.Relation;

public interface CreekModel extends java.io.Serializable
{

    public boolean addEntity( VisualEntity node );

    public boolean addEntityList( VertexList nodes );

    public void removeEntity( VisualEntity node );

    public boolean removeEntity(Entity e);

    public boolean removeEntityList( VertexList nodes );

    public boolean removeEntityList( Entity[] nodes );

    public boolean deleteEntityList( VertexList nodes );

    public VertexList getEntities();

    public VisualEntity[] getSelectedEntities();

    public void selectVertices(boolean state,VertexList vList);

    public void setSelected( VisualEntity v, boolean s );

    public void unselectAllVertices();

    public VisualEntity findVisualEntity( Entity e );

    public boolean moveEntityList( VertexList vl, int dx, int dy);




    public boolean addRelation( VisualRelation rel);

    public boolean addRelationList( RelationList relations );

    public RelationList getRelations();

    public boolean removeRelation( VisualRelation edgeToRemove );

    public boolean removeRelation(Relation r);

    public boolean removeRelationList( RelationList edges );

    public boolean removeRelationList( Relation[] edges );

    public boolean deleteRelationList( RelationList edges );

    public void selectRelations(boolean state,RelationList rList);

    public void setSelected( VisualRelation e, boolean s );

    public void unselectAllEdges();

    public VisualRelation findVisualRelation(Relation rel);



    public Relation[] getActiveRelations(VisualEntity ved);





    public void markDirty();


    public void addChangeListener( PropertyChangeListener listener );

    public void removeChangeListener( PropertyChangeListener listener );

    public void fireChange();

    public Graph getGraph();

    public void replace( Graph grp );

} // GraphModel
