package jcreek.cke.graph;

import jcreek.cke.util.DPoint;
import jcreek.cke.util.DDimension;
import jcreek.representation.Relation;
import jcreek.representation.Entity;
import jcreek.representation.RelationType;

import java.lang.Cloneable;
import java.io.Serializable;
import java.util.Iterator;



public interface Node  extends Serializable,Cloneable{

	public DPoint getPosition();

	public void setPosition(double x,double y);

        public void setSelected(boolean state);

        public boolean isSelected();

        public boolean addEdge(Edge edge);

        public void removeEdge(Edge edge);

        public boolean containsEdge(Edge edge);

        public void removeChild(Node child);

        public boolean containsChild(Node node);

        public Iterator getChildIterator();

        public int getNumChildren();

        public Iterator getEdgeIterator();

        public DDimension getBoundingBox();

        public Entity getEntity();

        public boolean relationIsActive(RelationType rcd);

        public boolean relationIsActive(Relation relation);

        public boolean relationIsActive(String relationName);

        public int getCount(Relation relation);


}