package jcreek.cke.importexport;
/**
 * This interface contains the control methods for a process, and
 * should be implemented in the import/ export classes. To be used
 * by the Process Status Window in a situation where the user tries
 * to close the window or push cancel and the process hasn't finished
 * yet. See e.g. 'JCXMLimport' or 'JCXMLexport' for examples of the
 * usage of this interface.
 *
 * @author Stein L. Tomassen, NTNU 2002
 */
public interface ProcessControlInterface {
	/**
	 * The method used to abort either an import or
   * export process.
	 */
	public void abortProcess();
}