package jcreek.cke.importexport;

/**
 * This interface contains some methods which enables the various plugins
 * to do some changes to the process status window. This interface
 * could be left out, but was implemented to ease the overview of the
 * various methods used to control the Process Status Window, hopefully.
 * See e.g. 'JCXMLimport' or 'JCXMLexport' for examples of the usage
 * of this interface.
 *
 * @author Stein L. Tomassen, NTNU 2002
 */
public interface ProcessStatusWindowInterface {
	/**
	 * The method to use to set the close button of the Process
   * Status Window, when e.g. the process has finished.
	 */
	public void setCloseButton();

	/**
	 * The method to use to set the cancel button of the Process
   * Status Window, when e.g. the process is to start and is
   * running.
	 */
	public void setCancelButton();

	/**
	 * The method to use during the process to keep the user informed of
   * what is going on.
   *
	 * @param text the text with information to the user.
	 */
	public void appendText(String text);
}
