package jcreek.cke.tool;

import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.JInternalFrame;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JInternalFrame;

import jcreek.cke.graph.CreekModel;
import jcreek.cke.conceptview.ConceptView;
import jcreek.cke.visualizer.EntityComboBoxModel;
import jcreek.cke.visualizer.RelationComboBoxModel;
import jcreek.cke.CreekDocumentGroup;
import jcreek.representation.KnowledgeModel;
import jcreek.representation.EntityTypeNotMatchedException;
import jcreek.representation.ModelChangeListener;
import jcreek.representation.ModelChangeEvent;

import jcreek.representation.KnowledgeModel;


import jcreek.representation.Entity;
import jcreek.representation.Relation;
import jcreek.representation.RelationType;


import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class BuildProperty implements PropertyWindow,PropertyChangeListener,ModelChangeListener {

  protected JPanel    framePanel = new JPanel(new BorderLayout());
  protected JComboBox relationClassList = new JComboBox() ;
  protected JComboBox entityClassList = new JComboBox();
  protected CreekModel model;
  protected JInternalFrame propWin;
  protected ConceptView view;

  public BuildProperty() {
    updateModelView();
    JLabel buildLabel = new JLabel(" Building");
    JPanel buildPanel = new JPanel(new BorderLayout());
    JPanel buildPanel2 = new JPanel(new GridLayout(4,0));
//    buildPanel2.setBorder(javax.swing.border.LineBorder.createGrayLineBorder());

//    buildPanel.setBackground(Color.white);
//    buildPanel2.setBackground(Color.white);

    JLabel buildRelationLabel = new JLabel(" Building Relation");
    buildRelationLabel.setForeground(Color.black);
    buildPanel2.add(buildRelationLabel);
    buildPanel2.add(relationClassList);
/*    JLabel buildEntityLabel = new JLabel(" Building Entity");
    buildEntityLabel.setForeground(Color.black);
    buildPanel2.add(buildEntityLabel);
    buildPanel2.add(entityClassList);
*/
    buildPanel.add(buildLabel, BorderLayout.NORTH);
    buildPanel.add(buildPanel2, BorderLayout.CENTER);

    framePanel.add(buildPanel, BorderLayout.NORTH);
    framePanel.setBackground(Color.white);

  }//BuildProperty

  public void updateModelView()
  {
    KnowledgeModel km = CreekDocumentGroup.instanceOf().getKM();
    if(km != null)
    {
        Object selectedEntity = entityClassList.getSelectedItem();
//        entityClassList = new JComboBox();
//        entityClassList.setModel(new DefaultComboBoxModel(new Entity[] {km.getEntity("Entity"), km.getEntity("Case")}));
//        Entity[] ents =
//        entityClassList.setMe
//        entityClassList = new JComboBox(ents);
//        entityClassList.setModel(new EntityComboBoxModel(km, km.getClassDescriptor(Entity.class)));
        entityClassList.setSelectedItem(selectedEntity);

        Object selectedRelation = relationClassList.getSelectedItem();
        relationClassList.setModel(new RelationComboBoxModel(km));
        relationClassList.setSelectedItem(selectedRelation);
    }
  }

  public void attach(CreekModel model,ConceptView view,JInternalFrame propWin) {
        this.model = model;
//        model.addChangeListener(this);
        CreekDocumentGroup.instanceOf().addPropertyChangeListener(this);
        if(CreekDocumentGroup.instanceOf().getKM() != null)
          CreekDocumentGroup.instanceOf().getKM().addModelChangeListener(this);
        this.propWin = propWin;
        propWin.setContentPane(framePanel);
        this.view = view;
        updateModelView();
        framePanel.validate();
        propWin.pack();
  }//attach

  public void detach() {
      if(model != null)
      {
//          model.removeChangeListener(this);
          model = null;
          CreekDocumentGroup.instanceOf().removePropertyChangeListener(this);
          if(CreekDocumentGroup.instanceOf().getKM() != null)
            CreekDocumentGroup.instanceOf().getKM().removeModelChangeListener(this);
      }
      if(propWin != null)
      {
          propWin.setContentPane(new JPanel());
          propWin = null;
      }
  }//detach

  public void modelChanged(ModelChangeEvent e)
  {
    updateModelView();
  }

    public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "knowledge" ) ) {
            if(e.getNewValue()!=null)
                updateModelView();
        }
    }//propertyChange


    public RelationType getSelectedRelation()
    {
      RelationType rcd = null;
      if(relationClassList.getSelectedIndex()!=-1)
      {
            RelationComboBoxModel rcdModel = (RelationComboBoxModel) relationClassList.getModel();
            try
            {
              rcd = (RelationType) new RelationType(rcdModel.getConceptAt(relationClassList.getSelectedIndex()));
            }
            catch(EntityTypeNotMatchedException e)
            {
            }
      }
      return rcd;
    }//getSelectedRelation

    public Entity getSelectedEntity()
    {
      Entity ecd = null;
      if(entityClassList.getSelectedIndex()!=-1)
      {
//          EntityComboBoxModel ecdModel = (EntityComboBoxModel) entityClassList.getModel();
          ecd =  (Entity) entityClassList.getSelectedItem();
//              (EntityClassDescriptor) ecdModel.getConceptAt(entityClassList.getSelectedIndex());
      }
      return ecd;
    }//getSelectedEntity

}//BuildProperty






