package jcreek.cke.tool;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */


import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.JInternalFrame;
import java.awt.*;
import java.awt.event.*;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;


import jcreek.cke.graph.CreekModel;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.conceptview.ConceptView;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.util.DDimension;
import jcreek.cke.visualizer.ScrollView;
import jcreek.cke.visualizer.ViewportScroller;

public class MoveProperty implements PropertyWindow,PropertyChangeListener {
  JPanel    framePanel = new JPanel(new BorderLayout());

  protected JInternalFrame propWin;

  protected ConceptView view;

  protected ViewportScroller scroller = new ViewportScroller(135, 90,
                                500.0, 500.0, 400.0, 400.0, 0.0, 0.0);

  protected ScrollView scrollView;

  public MoveProperty() {
        framePanel.add(scroller, BorderLayout.CENTER);
  }

  public void attach(CreekModel model, ConceptView view,JInternalFrame propWin) {
        this.propWin = propWin;
        propWin.setSize(new Dimension(180,180));
        propWin.setResizable(false);
        propWin.setContentPane(framePanel);
        this.view = view;
        scrollView = (ScrollView)((Component)view).getParent();
        DDimension tmp_dim;
        tmp_dim = scrollView.getPortSize();
        scroller.setPortSize(tmp_dim.width, tmp_dim.height);

        tmp_dim = scrollView.getContentSize();
        scroller.setContentSize(tmp_dim.width, tmp_dim.height);

        tmp_dim = scrollView.getOffset();
        scroller.setOffset(tmp_dim.width, tmp_dim.height);
        framePanel.validate();
        propWin.pack();

        scroller.addPropertyChangeListener(this);
        scrollView.addPropertyChangeListener(this);

  }

  public void detach() {
      if(propWin != null)
      {
          propWin.setContentPane(new JPanel());
          propWin.setResizable(true);
          propWin = null;
      }
      if(scroller !=null)
        scroller.removePropertyChangeListener(this);
      if(scrollView != null)
      {
        scrollView.removePropertyChangeListener(this);
        scrollView = null;
      }
      view = null;
  }

    public void propertyChange( PropertyChangeEvent e )
    {
        if ( e.getSource() instanceof ViewportScroller ) {
            scrollView.scrollTo(scroller.getOffsetX(),scroller.getOffsetY());
        }
        if ( e.getSource() instanceof ScrollView ) {
            if(e.getPropertyName() == "resize")
            {
               DDimension tmp_dim;

               tmp_dim = scrollView.getPortSize();
               scroller.setPortSize(tmp_dim.width, tmp_dim.height);

               tmp_dim = scrollView.getContentSize();
               scroller.setContentSize(tmp_dim.width, tmp_dim.height);

               tmp_dim = scrollView.getOffset();
               scroller.setOffset(tmp_dim.width, tmp_dim.height);

            }
            else if(e.getPropertyName() == "offset")
            {
               DDimension tmp_dim = scrollView.getOffset();
               scroller.setOffset(tmp_dim.width, tmp_dim.height);
            }
        }

    }

}