package jcreek.cke.tool;

import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.JInternalFrame;
import java.awt.*;
import java.awt.event.*;
import java.util.Hashtable;
import javax.swing.JInternalFrame;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import java.net.URL;

import jcreek.cke.graph.CreekModel;
import jcreek.cke.conceptview.ConceptView;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.command.ZoomCommand;
import jcreek.cke.MainWindow;


/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class ZoomProperty implements PropertyWindow,ChangeListener {

  JPanel    framePanel = new JPanel(new BorderLayout());

  protected JRadioButton zoomIn;
  protected JRadioButton zoomOut;

  JSlider      slider = new JSlider(JSlider.HORIZONTAL,25,200,100);

  protected CreekModel model;
  protected JInternalFrame propWin;
  protected ConceptView view;

  public ZoomProperty() {
        MainWindow mw = MainWindow.instanceOf();
        URL url;
        JPanel zoomPanel = new JPanel();

        // Create the zoom label radio button group.
        ButtonGroup bg = new ButtonGroup();
        JPanel controlPanel = new JPanel();
        controlPanel.setBorder( new TitledBorder
                         ( new EtchedBorder(),"Control") );

        // zoomIn allignment radio button
        url = mw.getResource( "ZoomInImage");
        zoomIn = new JRadioButton("Zoom In",/* new ImageIcon( url ),*/true);
        bg.add( zoomIn );
        controlPanel.add( zoomIn );

        // zoomOut allignment radio button
        url = mw.getResource( "ZoomOutImage");
        zoomOut = new JRadioButton("Zoom Out",/*new ImageIcon( url ),*/false);
        bg.add( zoomOut );
        controlPanel.add( zoomOut );



        //Create the slider and its label
        JLabel sliderLabel = new JLabel("Scale", JLabel.CENTER);
        sliderLabel.setAlignmentX(Component.CENTER_ALIGNMENT);

        slider.addChangeListener(this);

        //Turn on labels at major tick marks.
        slider.setMajorTickSpacing(25);
//        slider.setMinorTickSpacing(1);
        slider.setPaintTicks(true);
        slider.setPaintLabels(true);
        //Create the label table.
        Hashtable labelTable = new Hashtable();
        labelTable.put(new Integer( 25 ),
                       new JLabel("25%") );
        labelTable.put(new Integer( 100 ),
                       new JLabel("100%") );
        labelTable.put(new Integer( 200 ),
                       new JLabel("200%") );
        slider.setLabelTable(labelTable);
        slider.setBorder(
                BorderFactory.createEmptyBorder(0,0,10,0));
        JPanel scalePanel = new JPanel();
        scalePanel.setBorder( new TitledBorder
                         ( new EtchedBorder(),"Scale") );
        scalePanel.add(slider);

        //add all the components
        zoomPanel.setLayout(new BoxLayout(zoomPanel, BoxLayout.Y_AXIS));
//        zoomPanel.add(sliderLabel);
        zoomPanel.add( controlPanel);
        zoomPanel.add( scalePanel);

        framePanel.add(zoomPanel,BorderLayout.CENTER);

  }//ZoomProperty

  public void attach(CreekModel model,ConceptView view, JInternalFrame propWin) {
        this.model = model;
        this.propWin = propWin;
        propWin.setContentPane(framePanel);
        this.view = view;
        if(view!=null)
          setScale((int)(view.getScale()*100.0));
        framePanel.validate();
        propWin.pack();
  }//attach


  public void detach() {
      if(model != null)
      {
          model = null;
      }
      if(propWin != null)
      {
          propWin.setContentPane(new JPanel());
          propWin = null;
      }
      view = null;
  }//detach

  public boolean isZoomIn()
  {
      return zoomIn.isSelected();
  }

  public void stateChanged(ChangeEvent event)
  {
      CreekDocument doc = CreekDocumentGroup.instanceOf().getDocument(view);
      double scale = slider.getValue()/100.0;
      ZoomCommand zoomCmnd = new ZoomCommand(doc,scale);
      doc.performCommand(zoomCmnd);

  }

  public void setScale(int val)
  {
      slider.setValue(val);
  }

}//ZoomProperty



