package jcreek.cke.util;



/**
 *	A class for holding a real position.
 *	</p>Here is the <a href="../util/DPoint.java">source</a>.
 *
 *@author	Larry Barowski
**/
   public class DPoint
   {
      public double	x, y;


      public DPoint(double x_in, double y_in)
      {
         x = x_in;
         y = y_in;
      }



      public DPoint()
      {
      }



      public DPoint(DPoint init)
      {
         x = init.x;
         y = init.y;
      }



      public boolean equals(DPoint other)
      {
         if(other.x != x || other.y != y)
            return false;
         return true;
      }


      public void move(double new_x, double new_y)
      {
         x = new_x;
         y = new_y;
      }



      public void move(DPoint to)
      {
         x = to.x;
         y = to.y;
      }


      public void translate(double x_shift, double y_shift)
      {
         x += x_shift;
         y += y_shift;
      }


      public void transform(Matrix33 matrix)
      {
         double x2, y2,w2;
         double	mat[][] = matrix.matrix;
         x2 = mat[0][0] * x + mat[0][1] * y + mat[0][2] ;
         y2 = mat[1][0] * x + mat[1][1] * y + mat[1][2] ;
         w2 = mat[2][0] * x + mat[2][1] * y + mat[2][2] ;


         x = x2 / w2;
         y = y2 / w2;
/*
         x = x + mat[0][2];
         y = y + mat[1][2];
*/
      }

   }
