package jcreek.cke.util;

import java.awt.datatransfer.*;
import java.io.IOException;

import jcreek.cke.graph.VertexList;
import jcreek.cke.graph.RelationList;
import jcreek.cke.conceptview.*;


public class EntitySelection implements Transferable,ClipboardOwner {

  protected Object selection;
  protected DataFlavor flavor;

  public EntitySelection(Object selection,DataFlavor flavor) {
      this.selection = selection;
      this.flavor = flavor;
  }
  /**
   * Return the list of supported flavors
   */
  public DataFlavor[] getTransferDataFlavors() {
      return new DataFlavor[]{ flavor};
  }

  /**
   * Check whether we support a specified flavor
   */
  public boolean isDataFlavorSupported(DataFlavor f) {
        return f.equals(flavor);
  }

  /**
   * If the flavor is right tansfer the data
   */
  public Object getTransferData(DataFlavor f) throws UnsupportedFlavorException, IOException {
    try
    {
        if(f.equals(flavor))
        {

                return getClonedSelection();
        }
        else
            throw new UnsupportedFlavorException(f);
    }
    catch(Exception ex)
    {
        ex.printStackTrace();
        return null;
    }

  }

  /**
   * Called when data is no longer on the Clipboard
   */
  public void lostOwnership(Clipboard c,Transferable t)
  {
      selection = null;
  }


  public Object getClonedSelection()
  {
  /*
      SelectionSet set = (SelectionSet)selection;
      return set.copy();
*/
      VertexList vl = ((SelectionSet)selection).getVertexList();
      RelationList rl = ((SelectionSet)selection).getRelationList();

      VertexList cvl = new VertexList();
      RelationList crl = new RelationList();

      for(int i=0;i<vl.size();i++)
      {
          VisualEntity ove = vl.get(i);
          DPoint pt = ove.getPosition();
          VisualEntity nve = new VisualEntity(ove.getEntity(),
                    (int)pt.x,(int)pt.y);
          cvl.add(nve);
      }


      for(int j=0;j<rl.size();j++)
      {
          VisualRelation ovr = rl.get(j);
          System.out.println("ovr "+ovr.from+" - "+ovr.to+" - "+ovr);
          VisualRelation nvr = new VisualRelation(getVisualEntity(ovr.from,cvl),
                    getVisualEntity(ovr.to,cvl),ovr.getRelation());
          crl.add(nvr);
      }

      return (new SelectionSet(cvl,crl));

  }


  public VisualEntity getVisualEntity(VisualEntity ve,VertexList vl)
  {
    System.out.println("VE: "+ve+" vl: "+vl);
      for(int i=0;i<vl.size();i++)
      {
          if(ve.getEntity().equals(vl.get(i).getEntity()))
              return vl.get(i);
      }

      return null;
  }


  }