package jcreek.cke.visualizer;

import javax.swing.JPanel;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.JInternalFrame;
import java.lang.Number;
import java.text.NumberFormat;
import java.awt.*;
import java.awt.event.*;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;


import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import jcreek.cke.MainWindow;
import jcreek.representation.Entity;
import jcreek.representation.Relation;
import jcreek.representation.cbr.Case;
import jcreek.cke.graph.RelationList;
import jcreek.cke.graph.CreekModel;
import jcreek.representation.NameAlreadyExistException;
import jcreek.representation.RelationType;
import jcreek.representation.KnowledgeModel;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.command.ActivateEntityCommand;
import jcreek.cke.command.ActivateRelationCommand;
import jcreek.cke.command.DeleteRelationCommand;
import jcreek.gui.ExplanationView;
import jcreek.cke.browser.Visualizer;
import jcreek.cke.util.DPoint;
import jcreek.representation.ModelChangeListener;
import jcreek.representation.ModelChangeEvent;

import jcreek.gui.representation.*;
import jcreek.cke.conceptview.*;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Frode Srmo
 * @version 1.0
 */

public class CaseView extends JInternalFrame
                  implements PropertyChangeListener
{

  public CasePane casePane;
  protected LinkListener linkListener;

  public CaseView(Visualizer win, Case myCase)
  {
    super(myCase.getName()+" "+MainWindow.instanceOf().getResourceString("caseViewTitle"));
    initCaseView(win, new CasePane(myCase));
  }

  public CaseView(Visualizer win, KnowledgeModel km)
  {
    super("New Case");
    initCaseView(win, new CasePane(km));
  }

  protected void initCaseView(Visualizer win, CasePane cp)
  {
    casePane = cp;
    MainWindow mw = MainWindow.instanceOf();
    casePane.setEditable(CreekDocumentGroup.instanceOf().getKnowledgeModelEditable());
    casePane.addLinkListener(new PermanentFrameViewListener(this));
    casePane.attach();
    // Add ourselves as a document group listener so we will
    // know when to attach/detach  from the documents.
    CreekDocumentGroup.instanceOf().addPropertyChangeListener(this);

    setContentPane(new JScrollPane(cp));
//    System.out.println("FramePanel:"+cp.getPreferredSize()+" min: "+cp.getMinimumSize());

    setSize(cp.getPreferredSize().width+20, cp.getPreferredSize().height+100);
    setResizable(true);
    setIconifiable(false);
    setClosable(true);
    win.registerWindow(this);
    setVisible(true);
    addInternalFrameListener(new InternalFrameAdapter() {
      public void internalFrameClosed(InternalFrameEvent e)
      {
        ((CaseView) e.getInternalFrame()).casePane.detach();
      }
    });

    show();
  }

    /**
     * The state of the object we're listening to has changed.
     * This means we should check if any of the selected entities
     * have been removed.
     *
     * @param  e  change event
     */
    public void propertyChange( PropertyChangeEvent e )
    {
//      System.out.println("Event "+e+" name: "+e.getPropertyName());
        if(e.getSource() instanceof CreekDocumentGroup)
        {
              if(e.getPropertyName().equals("kmEditable"))
              {
                casePane.setEditable(((Boolean) e.getNewValue()).booleanValue());
              }
        }
    }//propertyChange


    static class PermanentFrameViewListener implements LinkListener
    {
      JComponent comp;
      PermanentFrameViewListener(JComponent comp)
      {
        this.comp = comp;
      }

      public void linkClicked(LinkEvent e)
      {
        FrameView.createPermanentFrameView((Entity) e.getConcept(), comp);
      }

      public void linkAction(LinkEvent e)
      {
      }
    }
}//FrameView






