package jcreek.cke.visualizer;

import javax.swing.ListModel;
import java.util.Vector;
import javax.swing.event.ListDataListener;
import javax.swing.event.ListDataEvent;
import java.util.Arrays;

import jcreek.representation.KnowledgeModel;
import jcreek.representation.Entity;
import jcreek.util.EntityNameComparator;


public class EntityListModel implements ListModel
{
  KnowledgeModel km;
  Entity[]     concepts;
  Vector         listeners = new Vector();

  public EntityListModel(KnowledgeModel km)
  {

    this.km = km;
   updateList();
  }

  void changeModel(KnowledgeModel km)
  {
    this.km = km;
    updateList();
  }

  protected Entity[] getConceptList()
  {
    if(km != null)
      return km.getEntities();
    else
      return new Entity[0];
  }

  protected void updateList()
  {

    concepts = getConceptList();

    Arrays.sort(concepts, new EntityNameComparator());

    for(int i=listeners.size()-1;i>=0;i--)
    {
      ((ListDataListener) listeners.elementAt(i)).contentsChanged(new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 0, 0));
    }
  }

  public void addListDataListener(ListDataListener l)
  {
    listeners.addElement(l);
  }

  public void removeListDataListener(ListDataListener l)
  {
    listeners.removeElement(l);
  }

  public Object getElementAt(int i)
  {
    return concepts[i].getName();
  }

  public Entity getConceptAt(int i)
  {
    return concepts[i];
  }

  public Entity getConcept(String name)
  {
      Entity con = null;
      for(int i=0;i<concepts.length;i++)
          if(concepts[i].getName()==name)
          {
              con = concepts[i];
              break;
          }
      return con;
  }

  public int getSize()
  {
    return concepts.length;
  }


  public void clear()
  {
    this.km = null;
    listeners.removeAllElements();
    updateList();

  }

}//EntityListModel
