package jcreek.cke.visualizer;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.awt.*;

import jcreek.representation.Entity;
import jcreek.representation.Relation;
import jcreek.representation.RelationType;
import jcreek.representation.KnowledgeModel;
import jcreek.cke.CreekDocumentGroup;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class EntityTableCellRenderer extends DefaultTableCellRenderer
{

  public Component getTableCellRendererComponent(JTable table,
                                               Object value,
                                               boolean isSelected,
                                               boolean hasFocus,
                                               int row,
                                               int column)
  {
    Component ret = super.getTableCellRendererComponent(table,value,isSelected,hasFocus,row,column);
    if(JComponent.class.isAssignableFrom(ret.getClass()))
    {
      JComponent comp = (JComponent) ret;
      comp.setToolTipText(value.toString());
      Relation myRel = ((EntityTableModel) table.getModel()).getRelationAt(row);


      if(isSelected)
      {
        comp.setBackground(Color.blue.brighter());
      }
      else
        if(myRel.isNegated())
          comp.setBackground(Color.red);
        else if(myRel.isInherited())
          comp.setBackground(Color.gray);
        else
          comp.setBackground(Color.white);


    }
    return ret;
  }

}//EntityTableCellRenderer
