package jcreek.cke.visualizer;

import javax.swing.JPanel;
import javax.swing.*;
import java.awt.*;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;


import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import jcreek.representation.Entity;
import jcreek.representation.KnowledgeModel;
import jcreek.cke.CreekDocumentGroup;
import jcreek.representation.ModelChangeListener;
import jcreek.representation.ModelChangeEvent;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class FrameProperty extends JPanel
                            implements PropertyChangeListener,
                            ModelChangeListener
{

    protected EntityProperties framePanel;
    protected EntityTableModel entityTableModel;
    protected JTable entityTable;

    protected Entity selEntity;

    public FrameProperty()
    {
        setLayout(new BorderLayout());
        framePanel = new EntityProperties();
        framePanel.getEntityNameText().setEditable(false);
        framePanel.getEntityDescriptionText().setEditable(false);

        entityTableModel = framePanel.getEntityTableModel();

        entityTable = framePanel.getEntityTable();

        framePanel.setUpRelationColumn(entityTable.getColumnModel().getColumn(0));
        framePanel.setUpEntityColumn(entityTable.getColumnModel().getColumn(1));
        framePanel.setUpStrengthColumn(entityTable.getColumnModel().getColumn(2));

        add(framePanel, BorderLayout.CENTER);
        // Add ourselves as a document group listener
        CreekDocumentGroup.instanceOf().addPropertyChangeListener(this );
   }


    public JComponent getComponent()
    {
        return ((JComponent)framePanel);
    }//getComponent



    public void updateModelView(Entity ent)
    {
        selEntity = ent;
        entityTableModel.setEntity(ent);
    }

    public void propertyChange( PropertyChangeEvent e ) {
        if(e.getSource() instanceof CreekDocumentGroup)
        {
              KnowledgeModel km = null;
              if(e.getPropertyName()=="opened")
              {
                  km = (KnowledgeModel)e.getNewValue();
                  km.addModelChangeListener(this);
              }
              else if(e.getPropertyName()=="closed")
              {
                  km = (KnowledgeModel)e.getOldValue();
                  km.removeModelChangeListener(this);
                  km = null;
                  selEntity = null;
              }
        }
    }//propertyChange

  public void modelChanged(ModelChangeEvent e)
  {
    if(e.getSource().equals(selEntity))
        updateModelView(null);
  }

}//MoveProperty






