package jcreek.cke.visualizer;

import javax.swing.JPanel;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.JInternalFrame;
import java.lang.Number;
import java.text.NumberFormat;
import java.awt.*;
import java.awt.event.*;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import jcreek.cke.MainWindow;
import jcreek.representation.Entity;
import jcreek.representation.Relation;
import jcreek.cke.graph.RelationList;
import jcreek.cke.graph.CreekModel;
import jcreek.representation.NameAlreadyExistException;
import jcreek.representation.RelationType;
import jcreek.representation.KnowledgeModel;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.document.CreekDocument;
import jcreek.cke.command.ActivateEntityCommand;
import jcreek.cke.command.ActivateRelationCommand;
import jcreek.cke.command.DeleteRelationCommand;
import jcreek.gui.ExplanationView;
import jcreek.cke.browser.Visualizer;
import jcreek.cke.util.DPoint;
import jcreek.representation.ModelChangeListener;
import jcreek.representation.ModelChangeEvent;
import jcreek.cke.conceptview.*;

import jcreek.gui.representation.*;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class FrameView extends JPanel
                  implements PropertyChangeListener
{

  public FramePane framePanel;
  protected LinkListener linkListener;
  protected boolean permanent = false;

  public FrameView()
  {
     setLayout(new BorderLayout());

        /*
        framePanel = new EntityProperties();
        JTextField entityNameText = framePanel.getEntityNameText();
        entityNameText.addFocusListener(new java.awt.event.FocusAdapter()
        {
          public void focusLost(FocusEvent e)
          {
            if(!e.isTemporary())
              framePanel.updateEntityName();
          }
        });
        entityNameText.addActionListener(new java.awt.event.ActionListener() {

          public void actionPerformed(ActionEvent e)
          {
            framePanel.updateEntityName();
          }
        });

        JTextArea entityDescriptionText = framePanel.getEntityDescriptionText();
        entityDescriptionText.addFocusListener(new java.awt.event.FocusAdapter()
        {
          public void focusLost(FocusEvent e)
          {
            if(!e.isTemporary())
              framePanel.updateEntityDescription();
          }
        });
        entityTable = framePanel.getEntityTable();
        entityTableModel = framePanel.getEntityTableModel();
        entityTableModel.addTableModelListener(new TableModelListener()
        {
          public void tableChanged(TableModelEvent e)
          {
            entityTable.getSelectionModel().clearSelection();
          }
        });

        entityTable.addMouseListener(new MouseAdapter()
        {
           public void mouseClicked(MouseEvent e)
           {
              if(e.getClickCount() == 2)
              {
                entityTableMouseClicked(e);
              }
           }
        });

        entityTable.registerKeyboardAction(new ActionListener()
        {
          public void actionPerformed(ActionEvent e)
          {
            entityTableRowDelete();
          }
        }, KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);


        framePanel.setUpRelationColumn(entityTable.getColumnModel().getColumn(0));
        framePanel.setUpEntityColumn(entityTable.getColumnModel().getColumn(1));
        framePanel.setUpStrengthColumn(entityTable.getColumnModel().getColumn(2));

        */

        MainWindow mw = MainWindow.instanceOf();

        framePanel = new FramePane();
        framePanel.setEditable(CreekDocumentGroup.instanceOf().getKnowledgeModelEditable());
        JScrollSpecial sp = new JScrollSpecial(framePanel, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
//        sp.setMinimumSize(this.getMinimumSize());
        add(sp, BorderLayout.CENTER);
        framePanel.addLinkListener(new PermanentFrameViewListener(this));
        framePanel.attach();
        // Add ourselves as a document group listener so we will
        // know when to attach/detach  from the documents.
        CreekDocumentGroup.instanceOf().addPropertyChangeListener(this );
    }

    public static void relationAction(Relation activate, JComponent comp)
    {

      if(activate.isInherited())
      {
        Visualizer win = Visualizer.getFrame(comp);
        JInternalFrame frame = new JInternalFrame(MainWindow.instanceOf().getResourceString("explanationTitle")+" "+activate.toString());
        ExplanationView ev = new ExplanationView(activate);
        frame.getContentPane().add(ev);
        frame.show();
        frame.setResizable(true);
        frame.setIconifiable(false);
        frame.setClosable(true);
        frame.setSize(800,600);
        win.registerWindow(frame);
        frame.setVisible(true);
      }
      else
      {
        ConceptView view = CreekDocumentGroup.instanceOf().getCurrentDocument().getView();
        CreekDocument doc  = CreekDocumentGroup.instanceOf().getCurrentDocument();
        CreekModel model = doc.getModel();
            VisualEntity vef,veto;
//            CreekDocument doc = CreekDocumentGroup.instanceOf().getDocument(view);
            DPoint tempPoint = view.activateEntity(null);
            vef = new VisualEntity(activate.getFrom(),(int)tempPoint.x,(int)tempPoint.y);
            ActivateEntityCommand aefAction = new ActivateEntityCommand( doc, vef );
            if ( doc.performCommand( aefAction ) == true )
            {
                vef = model.findVisualEntity(activate.getFrom());
                if(vef == null)
                {
                  JOptionPane.showMessageDialog
                      ( comp,
                        MainWindow.instanceOf().getResourceString( "nodeAddMsg" ),
                        MainWindow.instanceOf().getResourceString( "userError"+Visualizer.titleSuffix),
                        JOptionPane.ERROR_MESSAGE );
                    return;
                }
            }
            tempPoint = view.activateEntity(vef);
            veto = new VisualEntity((Entity)activate.getValue(),(int)tempPoint.x,(int)tempPoint.y);
            ActivateEntityCommand aetAction = new ActivateEntityCommand( doc, veto );
            if ( doc.performCommand( aetAction ) == true )
            {
                veto = model.findVisualEntity((Entity)activate.getValue());
                if(veto == null)
                {
                  JOptionPane.showMessageDialog
                      ( comp,
                        MainWindow.instanceOf().getResourceString( "nodeAddMsg" ),
                        MainWindow.instanceOf().getResourceString( "userError"+Visualizer.titleSuffix),
                        JOptionPane.ERROR_MESSAGE );
                    return;
                }
            }
            VisualRelation vr = new VisualRelation(vef,veto,activate);
            ActivateRelationCommand arAction = new ActivateRelationCommand( doc, vr );
            if ( doc.performCommand( arAction ) == false )
            {
                  JOptionPane.showMessageDialog
                      ( comp,
                        MainWindow.instanceOf().getResourceString( "edgeAddMsg" ),
                        MainWindow.instanceOf().getResourceString("userError"+Visualizer.titleSuffix),
                        JOptionPane.ERROR_MESSAGE );
            }
      }

    }

    public JComponent getComponent()
    {
        return ((JComponent)framePanel);
    }//getComponent


    /**
     * The state of the object we're listening to has changed.
     * This means we should check if any of the selected entities
     * have been removed.
     *
     * @param  e  change event
     */
    public void propertyChange( PropertyChangeEvent e )
    {
//      System.out.println("Event "+e+" name: "+e.getPropertyName());
        if(e.getSource() instanceof CreekDocumentGroup)
        {
              if(e.getPropertyName().equals("kmEditable"))
              {
                framePanel.setEditable(((Boolean) e.getNewValue()).booleanValue());
              }
              else if ((e.getPropertyName().equals( "selection" )  || e.getPropertyName().equals( "current" )) && !permanent)
                updateModelView();

        }
        else if(e.getSource() instanceof CreekModel)
        {
            if ((e.getPropertyName().equals( "selection" )  || e.getPropertyName().equals( "change" )) && !permanent)
                updateModelView();
        }
    }//propertyChange

    public void updateModelView()
    {
      CreekDocument doc = CreekDocumentGroup.instanceOf().getCurrentDocument();
      if(doc != null)
      {
        CreekModel model = doc.getModel();

        if(model!=null)
        {
          VisualEntity[] ent = model.getSelectedEntities();
          if(ent.length > 0)
            framePanel.setEntity(((VisualEntity)ent[0]).getEntity());
          else
            framePanel.setEntity(null);
        }
        else
          framePanel.setEntity(null);
      }
      else
        framePanel.setEntity(null);
        validate();
        repaint();
    }
    public static void createPermanentFrameView(Entity entity, JComponent comp)
    {
      Visualizer win = Visualizer.getFrame(comp);
      createPermanentFrameView(entity, win);
    }

    public static void createPermanentFrameView(Entity entity, Visualizer win)
    {

      JInternalFrame frame = new JInternalFrame(entity.getName()+" "+MainWindow.instanceOf().getResourceString("frameViewTitle"));
      FrameView cp = new FrameView();
      cp.framePanel.setEntity(entity);
      cp.framePanel.attach();
      cp.permanent = true;
      frame.setContentPane(cp);
//      System.out.println("FramePanel:"+cp.getPreferredSize()+" min: "+cp.getMinimumSize());

      Dimension size = cp.getPreferredSize();
      size.width += 22;
      size.height += 80;

      if(size.width > 500)
        size.width = 500;
      if(size.height > 600)
        size.height = 600;

      frame.setSize(size);
      frame.setResizable(true);
      frame.setIconifiable(false);
      frame.setClosable(true);
      win.registerWindow(frame);
      frame.setVisible(true);
      frame.addInternalFrameListener(new InternalFrameAdapter() {
        public void internalFrameClosed(InternalFrameEvent e)
        {
          ((FrameView) e.getInternalFrame().getContentPane()).framePanel.detach();
//          ((FrameView) ((JViewport) e.getInternalFrame().getContentPane().getComponent(0)).getView()).framePanel.detach();
        }
      });

      frame.show();
    }

    public void setForInput()
    {
      framePanel.entityName.requestFocus();
      framePanel.entityName.selectAll();
    }

/*    public Dimension getPreferredSize()
    {
      return framePanel.getPreferredSize();
    }

    public Dimension getMinimumSize()
    {
      return framePanel.getMinimumSize();
    }
*/
/*
  public void conceptRemoved(ModelChangeEvent e)
  {
      updateModelView();
  }

  public void conceptChanged(ModelChangeEvent e)
  {
      updateModelView();
  }

  public void conceptAdded(ModelChangeEvent e)
  {
  }

*/
    class PermanentFrameViewListener implements LinkListener
    {
      JComponent comp;
      PermanentFrameViewListener(JComponent comp)
      {
        this.comp = comp;
      }

      public void linkClicked(LinkEvent e)
      {
        createPermanentFrameView((Entity) e.getConcept(), comp);
      }

      public void linkAction(LinkEvent e)
      {
        System.out.println("linkAction: "+e);
        Relation rel = (Relation) e.getConcept();
        if(framePanel.isEditable())
          return;
        relationAction(rel, comp);
      }
    }

    class JScrollSpecial extends JScrollPane
    {
      JScrollSpecial(JComponent frame, int vpolicy, int hpolicy)
      {
        super(frame, vpolicy, hpolicy);
      }

      public Dimension getMinimumSize()
      {
        Dimension dim = this.getViewport().getView().getMinimumSize();
        if(this.getVerticalScrollBar().isVisible())
          dim.width = dim.width + this.getVerticalScrollBar().getSize().width;
        return dim;
      }

      public Dimension getPreferredSize()
      {
        Dimension dim = this.getViewport().getView().getPreferredSize();
        if(this.getVerticalScrollBar().isVisible())
          dim.width = dim.width + this.getVerticalScrollBar().getSize().width;
        return dim;
      }
    }
}//FrameView






