package jcreek.cke.visualizer;

import jcreek.cke.conceptview.*;

import java.awt.*;
import javax.swing.JInternalFrame;

public class MultiInternalFrame extends JInternalFrame {
	private ConceptView internalDrawingView;

	/**
	 * Create a new internal frame
	 */
	public MultiInternalFrame() {
		super();
	}

	/**
	 * Create a new internal frame with a given name
	 *
	 * @param   title       name of the internal frame
	 */
	public MultiInternalFrame(String title) {
		super(title);
	}

	/**
	 * Create a new internal frame with a given name
	 *
	 * @param   title       name of the internal frame
	 * @param   resizable   true, if the frame is resizable
	 */
	public MultiInternalFrame(String title, boolean resizable) {
		super(title, resizable);
	}

	/**
	 * Create a new internal frame with a given name
	 *
	 * @param   title       name of the internal frame
	 * @param   resizable   true, if the frame is resizable
	 * @param   closable    true, if the frame is closable
	 */
	public MultiInternalFrame(String title, boolean resizable, boolean closable) {
		super(title, resizable, closable);
	}

	/**
	 * Create a new internal frame with a given name
	 *
	 * @param   title       name of the internal frame
	 * @param   resizable   true, if the frame is resizable
	 * @param   closable    true, if the frame is closable
	 * @param   maximizable true, if the frame is maximizable
	 */
	public MultiInternalFrame(String title, boolean resizable, boolean closable, boolean maximizable) {
		super(title, resizable, closable, maximizable);
	}

	/**
	 * Create a new internal frame with a given name
	 *
	 * @param   title       name of the internal frame
	 * @param   resizable   true, if the frame is resizable
	 * @param   closable    true, if the frame is closable
	 * @param   maximizable true, if the frame is maximizable
	 * @param   iconifiable ture, if the frame is iconifiable
	 */
	public MultiInternalFrame(String title, boolean resizable, boolean closable, boolean maximizable, boolean iconifiable) {
		super(title, resizable, closable, maximizable, iconifiable);
	}

	/**
	 * Set the Concept view which represents the internal frame
	 *
	 * @param   newInternalDrawingView  drawing view for this internal frame
	 */
	public void setConceptView(ConceptView newInternalDrawingView) {
		internalDrawingView = newInternalDrawingView;
	}

	/**
	 * Get the Concept view which represents the internal frame
	 *
	 * @param   newInternalDrawingView  drawing view for this internal frame
	 */
	public ConceptView getConceptView() {
		return internalDrawingView;
	}


}