package jcreek.cke.visualizer;

import javax.swing.*;
import javax.swing.border.EmptyBorder;

import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.AWTEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;

import jcreek.cke.MainWindow;
import jcreek.cke.browser.Visualizer;
import jcreek.cke.CreekDocumentGroup;
import jcreek.representation.KnowledgeModel;
import jcreek.representation.NameAlreadyExistException;
import jcreek.cke.controls.*;
import jcreek.representation.Entity;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class NewEntityDialog extends JDialog implements ActionListener{

  private JButton okButton      = new JButton();
  private JButton cancelButton  = new JButton();

  protected JComboBox entityClassList   = new JComboBox();

  protected boolean isOk = false;

  public NewEntityDialog(Frame owner,String title) {
      super(owner,title,true);
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      try {
        jbInit();
      }
      catch(Exception e) {
        e.printStackTrace();
      }
  }

  private void jbInit() throws Exception {

    MainWindow mw = MainWindow.instanceOf();
    JPanel content = new JPanel(new BorderLayout());
    content.setBorder(new EmptyBorder(12,12,12,12));
    setContentPane(content);

    JPanel buttons = new JPanel();
    buttons.setLayout(new BoxLayout(buttons,BoxLayout.X_AXIS));
    buttons.setBorder(new EmptyBorder(12,0,0,0));
    buttons.add(Box.createGlue());
    okButton.setText(mw.getResourceString("okLabel"));
    okButton.addActionListener( this );
    buttons.add(okButton);
    buttons.add(Box.createHorizontalStrut(6));
    cancelButton.setText(mw.getResourceString("cancelLabel"));
    cancelButton.addActionListener( this );
    buttons.add(cancelButton);
    buttons.add(Box.createGlue());

    getRootPane().setDefaultButton(cancelButton);

    content.add(BorderLayout.SOUTH,buttons);

    JPanel relPanel = new JPanel();

    KnowledgeModel km = CreekDocumentGroup.instanceOf().getKM();
    if(km != null)
    {
        entityClassList.setModel(new EntityComboBoxModel(km));
        entityClassList.setSelectedIndex(0);
    }
    relPanel.add(entityClassList);

    content.add(BorderLayout.CENTER,relPanel);

    pack();
    setLocationRelativeTo(getOwner());
    show();

  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

    void cancel() {
      hide();
      dispose();
    }

    public boolean isOK()
    {
        return isOk;
    }

    public void actionPerformed( ActionEvent e )
   {
        String command = e.getActionCommand();
        if ( command.equals(MainWindow.instanceOf().getResourceString("okLabel")))
        {

                    int i = 0;
                   String entName = "New Entity";
                   KnowledgeModel km = CreekDocumentGroup.instanceOf().getKM();
                    while(km.getEntity(entName) != null)
                    {
                        i++;
                        entName = "New Entity ("+i+")";
                    }
                    try
                    {
                      Entity newEnt = new Entity(CreekDocumentGroup.instanceOf().getKM(), "New Entity"+(i==0?"":" ("+i+")"), "");
                      displayFrameProperty((Visualizer)getOwner(),newEnt);
                    }
                    catch(NameAlreadyExistException err)
                    {
                      err.printStackTrace();
                    }

              isOk = true;
              dispose();
        }
        else if(command.equals(MainWindow.instanceOf().getResourceString("cancelLabel")))
        {
              isOk = false;
              dispose();
        }
    }


    public void displayFrameProperty(Visualizer win,Entity selEntity)
    {
        win.displayPropertyWindow(selEntity);
    }//displayFrameProperty


}