package jcreek.cke.visualizer;

import java.awt.BorderLayout;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;
import javax.swing.ImageIcon;
import java.net.URL;

import jcreek.cke.MainWindow;
import jcreek.cke.browser.Visualizer;
import jcreek.representation.Entity;

/**
 * Title:        JavaCreek
 * Description:  A Case based Reasoning Approach in java
 * Copyright:    Copyright (c) 2002
 * Company:      Phil
 * @author Victor
 * @version 1.0
 */

public class PropertyControl extends JPanel
{

  private JLabel viewButton;
  private ViewControl viewControl = new ViewControl();

  private FrameProperty frameProperty =  new FrameProperty();

  public PropertyControl() {
      this(true);
  }

   public PropertyControl(boolean showViewButton)
   {
      super(new FlowLayout(FlowLayout.RIGHT,5,0));
      setBorder(BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
      URL url = MainWindow.instanceOf().getResource( "exit" + Visualizer.imageSuffix );
      viewButton = new JLabel(new ImageIcon(url)); // Note: We use a label since it takes much less space than a button
      viewButton.setEnabled(false);
      viewButton.addMouseListener(new java.awt.event.MouseAdapter()
      {
         public void mouseClicked(java.awt.event.MouseEvent e)
         {
                deleteSelectedItem();
         }
      });
      viewControl.addActionListener(new java.awt.event.ActionListener()
      {
          public void actionPerformed(java.awt.event.ActionEvent e)
          {
              displaySelectedItem();
          }
      });
      add(viewControl);
      add(viewButton);
      viewButton.setVisible(showViewButton);
      setAlignmentX(0.9f);
   }

  public void displayProperty(Entity ent)
  {
      addEntity(ent);
      displaySelectedItem();
      viewButton.setEnabled(true);
  }

  public void displaySelectedItem()
  {
      Visualizer win = Visualizer.getFrame(this);
      if(viewControl.getItemCount()>0)
      {
          Entity selEntity = (Entity) viewControl.getSelectedItem();
          if(selEntity!= null)
          {
              frameProperty.updateModelView(selEntity);
              JInternalFrame jWin = (JInternalFrame)win.getPropertyWindow();
              if(jWin!=null)
              {
                jWin.setContentPane(frameProperty);
                jWin.setTitle(selEntity.getName()+" "+
                MainWindow.instanceOf().getResourceString("permanentFrame"+Visualizer.titleSuffix));
              }
          }
      }
  }

  public void addEntity(Entity ent)
  {
      for(int i=0;i<viewControl.getItemCount();i++)
      {
          if(((Entity)viewControl.getItemAt(i))==ent)
          {
                viewControl.setSelectedIndex(i);
                return;
          }
      }
      viewControl.addItem(ent);
      viewControl.setSelectedItem(ent);
  }


  public void deleteSelectedItem()
  {
      Visualizer win = Visualizer.getFrame(this);
      if(viewControl.getItemCount()>0)
      {
          viewControl.removeItemAt(viewControl.getSelectedIndex());
          if(viewControl.getItemCount()>0)
              viewButton.setEnabled(true);
          else
              viewButton.setEnabled(false);
      }
      if(viewControl.getItemCount()==0)
          ((JInternalFrame)win.getPropertyWindow()).setVisible(false);
  }

  private class  ViewControl extends JComboBox
  {
      public Dimension getMinimumSize()
      {
          return new Dimension(125,17);
      }

      public Dimension getPreferredSize()
      {
          return getMinimumSize();
      }
  }

}






