package jcreek.cke.visualizer;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.BoxLayout;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class ScaleControl extends JPanel
{

	protected NumberField numField;
	protected ButtonPanel bPanel;

  public ScaleControl()
  {
		super( );
		init();
  }

	public void init()
	{
                setMinimumSize(new Dimension(8,10));
		bPanel = new ButtonPanel(this);
		numField = new NumberField("1",3);
    add(numField);
    add(bPanel);
	}

  public void increment()
  {
      int numval = 0;
      String val = numField.getText();
      try
      {
          numval = Integer.parseInt(val);
          val = String.valueOf(++numval);
      }
      catch(NumberFormatException ex)
      {
          numval = 1;
          val = "1";
//          ex.printStackTrace();
      }
      if(numval < 100)
          numField.setText(val);
  }

  public void decrement()
  {
      int numval = 0;
      String val = numField.getText();
      try
      {
          numval = Integer.parseInt(val);
          val = String.valueOf(--numval);
      }
      catch(NumberFormatException ex)
      {
          numval = 1;
          val = "1";
          ex.printStackTrace();
      }
      if(numval >0)
          numField.setText(val);
  }

  public int getIntValue()
  {
      int numValue = 1;
      try
      {
          numValue = Integer.parseInt(numField.getText());
      }
      catch(NumberFormatException ex)
      {
          ex.printStackTrace();
          return 1;
      }
      return numValue;
  }

}
class ButtonPanel extends JPanel implements ActionListener
{
  protected JButton incr;
  protected JButton decr;

  protected ScaleControl sControl;

  public ButtonPanel(JPanel sc)
  {
      setMinimumSize(new Dimension(4,10));
      sControl = (ScaleControl)sc;
      incr = new JButton("^");
      incr.setMinimumSize(new Dimension(4,5));
      incr.addActionListener(this);
      decr = new JButton("v");
      decr.setMinimumSize(new Dimension(4,5));
      decr.addActionListener(this);

      setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
      add(incr);
      add(decr);
  }

  public void actionPerformed(ActionEvent e)
  {
      if(e.getActionCommand().equals("^"))
          sControl.increment();
      else
          sControl.decrement();
  }
}

class NumberField extends JTextField
{
    public NumberField(String str,int cols)
    {
        super(str,cols);
        setMinimumSize(new Dimension(4,5));
    }

    protected Document createDefaultModel()
    {
        return new NumberDocument();
    }


    static class NumberDocument extends PlainDocument
    {
        public void insertString(int offs, String str,AttributeSet a) throws BadLocationException
        {
          String curStr = getText(0,getLength());
          int num;
          try
          {
              if(str == null)
                  return;
              if(offs==0)
                  str = str.concat(curStr);
              else
              {
                curStr =curStr.substring(0,offs);
                str = curStr.concat(str);
              }
              num = Integer.parseInt(str);
              if(num == 0)
              {
                num = 1;
                str = "1";
              }
              if((num > 100) || (num < 1))
                  return;

          }
          catch(NumberFormatException ex)
          {
              return;
          }
          remove(0,getLength());
          super.insertString(0,str,a);
        }

    }
}

