package jcreek.gui.chart;

import java.awt.Color;

/**
 * Title:        JavaCreek
 * Description:  Describes a data model used by the JChart class to display a
 *               2D bar chart.
 * Copyright:    Copyright (c) 2002
 * Company:      NTNU
 * @author       Frode Srmo
 * @version 1.0
 */

public interface ChartModel
{
    public double getValue(int col, int row);
    public String getValueLabel(int col, int row);
    public String getRowLabel(int i);
    public int getRowSize();
    public int getColSize(int row);
    public double getMaxValue();
    public Color getValueColor(int col, int row);
    public Color getBackgroundColor(int row);
}
