package jcreek.gui.conceptmap;

/**
 * Handles the transfer between components of entities and relations.
 *
 * @author Frode Srmo
 * @version 1.0
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import javax.swing.*;
import jcreek.representation.*; import jcreek.representation.cbr.*;

public class EntityTransferable implements Transferable
{
  private static DataFlavor entityDataFlavor = null;

  private Object entityID;

  public static DataFlavor getEntityDataFlavor()
  {
    if(entityDataFlavor == null)
    {
      try
      {
        entityDataFlavor = new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType+";class=jcreek.representation.Entity");
      }
      catch(ClassNotFoundException e)
      {
        e.printStackTrace();
      }
    }
    return entityDataFlavor;
  }

  /**
   * Creates a new Transferrable for the given single Entity.
   */
  public EntityTransferable(Entity entity)
  {
    entityID  = entity.getID();
  }

  public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException
  {
    if (!isDataFlavorSupported(flavor)) {
        throw new UnsupportedFlavorException(flavor);
    }
    return entityID;
  }

  public DataFlavor[] getTransferDataFlavors()
  {
    return new DataFlavor[] { getEntityDataFlavor() };
  }

  public boolean isDataFlavorSupported(DataFlavor flavor)
  {
    if (getEntityDataFlavor().equals(flavor))
    {
      return true;
    }
    return false;
  }
}
