package jcreek.gui.conceptmap;

/**
 * Handles the transfer between components of relations.
 *
 * @author Frode Srmo
 * @version 1.0
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import javax.swing.*;
import jcreek.representation.*; import jcreek.representation.cbr.*;

public class RelationTransferable implements Transferable
{
  private static DataFlavor relationDataFlavor = null;

  private Object relationID;


  public static DataFlavor getRelationDataFlavor()
  {
    if(relationDataFlavor == null)
    {
      try
      {
        relationDataFlavor = new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType+";class=jcreek.representation.Relation");
      }
      catch(ClassNotFoundException e)
      {
        e.printStackTrace();
      }
    }
    return relationDataFlavor;
  }

  /**
   * Creates a new Transferrable for the given single Entity.
   */
  public RelationTransferable(Relation relation)
  {
    relationID  = relation.getID();
  }

  public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException
  {
    if (!isDataFlavorSupported(flavor)) {
        throw new UnsupportedFlavorException(flavor);
    }
    return relationID;
  }

  public DataFlavor[] getTransferDataFlavors()
  {
    return new DataFlavor[] { getRelationDataFlavor() };
  }

  public boolean isDataFlavorSupported(DataFlavor flavor)
  {
    if (getRelationDataFlavor().equals(flavor))
    {
      return true;
    }
    return false;
  }
}
