package jcreek.gui.reasoning;

import jcreek.reasoning.*;
import javax.swing.*;
import java.awt.*;

/**
 * This is a small adaption of the EntityComparisonPane that will display a
 * greater part of the textual explanation in a SymbolComparison.
 *
 * @author Frode Srmo
 * @version 2.0
 */

public class SymbolComparisonPane extends EntityComparisonPane
{
  public SymbolComparisonPane(SymbolComparison comp)
  {
    super(comp);
  }

  protected JComponent buildDescriptionPane()
  {
    JPanel info = new JPanel();
    info.setLayout(new GridLayout(6,2));
    info.add(new JLabel("Origin"));
    info.add(new JLabel(getSymbolComparison().getOrigin().getValueString()));
    info.add(new JLabel("Target"));
    info.add(new JLabel(getSymbolComparison().getTarget().getValueString()));
    info.add(new JLabel("Status"));
    info.add(new JLabel(getSymbolComparison().getStatusText()));
    info.add(new JLabel("Activation strength"));
    info.add(new JLabel(""+(int) Math.round(getSymbolComparison().getActivationStrength()*100)+"%"));
    info.add(new JLabel("Explanation strength"));
    info.add(new JLabel(""+(int) Math.round(getSymbolComparison().getExplanationStrength()*100)+"%"));
    info.add(new JLabel("Total strength"));
    info.add(new JLabel(""+(int) Math.round(getSymbolComparison().getStrength()*100)+"%"));
    JPanel explanationPanel = new JPanel(new BorderLayout());
    explanationPanel.add(info, BorderLayout.NORTH);
    JTextArea explanation = new JTextArea(10, 30);
    explanation.setEditable(false);
    explanation.setWrapStyleWord(true);
    explanation.setLineWrap(true);
    explanation.setText(getSymbolComparison().toString());
    explanationPanel.add(new JScrollPane(explanation), BorderLayout.CENTER);
    return explanationPanel;
  }

  protected JComponent buildSubModelView()
  {
    return new ComparisonSubModelView(getSymbolComparison().toCompleteSubModel(), getSymbolComparison().getOrigin(), getSymbolComparison().getTarget());
  }


  public SymbolComparison getSymbolComparison()
  {
    return (SymbolComparison) getEntityComparison();
  }

}
