package jcreek.gui.representation;

/**
 * Implements a cell editor and renderer for entities that are of the Number
 * type.
 *
 * @author Frode Srmo
 * @version 1.0
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import jcreek.representation.*; import jcreek.representation.cbr.*;

public class DoubleTypeField extends AbstractEntityTypeField
{
  JLabel renderComponent = new JLabel();
  JTextField editorComponent = new JTextField();
  Class editingClass;

  public DoubleTypeField()
  {
    super();
  }

  public Component getRendererComponent(Object value)
  {
    if(value == null || !(value instanceof Double))
     value = new Double(0.0);

   renderComponent.setText( ( (Number) value).toString());
   editingClass = value.getClass();

   return renderComponent;
  }

  public Component getEditorComponent(Object value)
  {
    if(value == null || !(value instanceof Double))
      value = new Double(0.0);

    editorComponent.setText(((Double) value).toString());
    editorComponent.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e)
      {
        stopCellEditing();
      }
    });

    return editorComponent;
  }

  public Object getCellEditorValue()
  {
    try
    {
      Double value = Double.valueOf(editorComponent.getText());
      return value;
    }
    catch(NumberFormatException e)
    {
    }
    return null;
  }
}
