package jcreek.gui.representation;

/**
 * Cell editor for tables etc. that allows the change of the symbol value in
 * e.g. a relation.
 * @author not attributable
 * @version 1.0
 */

import jcreek.representation.*; import jcreek.representation.cbr.*;

import javax.swing.*;
import javax.swing.table.TableCellEditor;

public class SymbolCellEditor // extends AbstractCellEditor implements TableCellEditor
{
  JComponent editor;
  /**
   * Creates a new SymbolCellEditor that contains a drop-list of the values
   * of some kind of attribute type. For instance the attribute type "Color"
   * may have the values "Red", "Blue", etc.
   * @param type The entity representing the type of value, e.g. "Color" in the example above.
   */
  public SymbolCellEditor(Entity type)
  {
    super();

    Relation[] values = type.getRelations(CBRModel.HAS_INSTANCE);
    Entity[] entities = new Entity[values.length+1];
    entities[values.length] = type.getKnowledgeModel().getEntity(CBRModel.NO_VALUE);

    for(int i=0;i<values.length;i++)
      entities[i] = values[i].getValue();

    editor = new JList(entities);
  }

  /**
   * Creates a new SymbolCellEditor that limits the set of possible values
   * according to the restrictions placed on a RelationType
   */

}
