package jcreek.gui.representation;

import jcreek.representation.*; import jcreek.representation.cbr.*;
//import jcreek.reasoning.NumberComparison;
//import jcreek.reasoning.SymbolComparison;
import javax.swing.*;
import java.awt.event.*;
import java.awt.Color;


/**
 * Provicdes a Swing component to display/edit an Entity object. At the moment,
 * it only supports Double.
 *
 * @author Frode Srmo
 * @version 0.9
 */
class ValueComponentFactory
{
  private ValueComponentFactory()
  {
  }

  public static JComponent getValueComponent(Entity ent, boolean editable)
  {
    Object valueObject = ent.getEntityObject();
    if(valueObject == null)
      return new JLabel("<No Value>");

    if(valueObject instanceof Double)
    {
      JTextField doubleField = new JTextField(valueObject.toString());
      if(editable)
      {
        doubleField.addFocusListener(new DoubleFocusListener(ent, doubleField));
      }
      doubleField.setEditable(editable);
      return doubleField;
    }
    return new JLabel(valueObject.toString());
  }

  static class DoubleFocusListener implements FocusListener
  {
    Entity ent;
    JTextField field;
    DoubleFocusListener(Entity ent, JTextField field)
    {
      this.ent = ent;
      this.field = field;
    }

    public void focusGained(FocusEvent e)
    {
    }

    public void focusLost(FocusEvent e)
    {
      try
      {
        Double val = new Double(field.getText());
        ent.setEntityObject(val);
      }
      catch(NumberFormatException ex)
      {
        field.setBorder(BorderFactory.createLineBorder(Color.red,1));
      }
    }
  }
}
