package jcreek.reasoning;

import java.util.EventObject;

/**
 * An object of this class represents an event in a reasoning step.
*
 * @author Frode Srmo
 * @version 1.0
 */

public class ReasoningUpdateEvent extends EventObject
{
  /**
   * Creates a new ReasoningUpdateEvent originating from the source of the
   * given type (see static final constants).
   *
   * @param source The source producing the event.
   * @param eventType The type of event.
   */

  public static final int REASONING_ABORTED = 0;
  public static final int REASONING_UPDATESTARTED = 1;
  public static final int REASONING_STATECHANGED = 2;

  private int type = -1;

  public ReasoningUpdateEvent(CBRReasoningStep source, int eventType)
  {
    super(source);
    this.type = eventType;
  }

  /**
   * Returns the type of event this is.
   */
  public int getType()
  {
    return type;
  }

  /**
   * Returns the source of this event (a CBRReasoningStep instance)
   */
  public CBRReasoningStep getReasoningStep()
  {
    return (CBRReasoningStep) getSource();
  }
}
