package jcreek.reasoning;

import java.util.EventListener;

/**
 * A class implementing this interface may be registered with reasoning
 * classes to recieve messages about status changes in the reasoning process.
 * @author Frode Srmo
 * @version 1.0
 */

public interface ReasoningUpdateListener extends EventListener
{
  /**
   * Called whenever the reasoning recognizes a change in the underlaying model
   * that requires that the reasoning is redone.
   */
  public void reasoningUpdateStarted(ReasoningUpdateEvent e);

  /**
   * Called whenever a reasoning state is changed.
   * @param e ReasoningUpdateEvent
   */
  public void reasoningStateChanged(ReasoningUpdateEvent e);

  /**
   * Called whenever the reasoning
   * @param e ReasoningUpdateEvent
   */
  public void reasoningAborted(ReasoningUpdateEvent e);
}
