package jcreek.representation;

/**
 * The epistemological model is a top level model that establishes entities,
 * relations and relation types that are required by the representation and
 * basic inference system. The epistemological model usually also contains
 * a structure and a "view of the world" as to how knowledge models should be
 * built.
 *
 * @author Frode Srmo
 * @version 1.0
 */

public interface EpistemologicalModel
{
  /**
   * Generate the epistemological in the (empty) supplied knowledge model.
   *
   * @param km KnowledgeModel
   */
  public void generateEpistemologicalModel(KnowledgeModel km);
}
