package jcreek.representation;

import jcreek.util.CreekException;

/**
 * hrown when attempting to reference an entity by a string
 * and this string does not identify an entity in the current knowledge model.
 * @author Frode Srmo
 * @version 1.0
 */

public class NoSuchEntityException extends CreekException
{
  private String relationName;

  /**
   * Creates a new NoSuchRelationTypeException with the given string.
   */
  public NoSuchEntityException(String relationName)
  {
    super("No entity with the name '"+relationName+"' found");
    this.relationName = relationName;
  }

  /**
   * The string supplied as a relation type name for which there is no matching
   * relation type in the current knowledge model.
   */
  public String getRelationName()
  {
    return relationName;
  }
}

