package jcreek.representation.cbr;

/**
 * <p>Title: IsoPod</p>
 * <p>Description: Interface to allow the use of constants to refer to
 * system relations and entities. The keys these constants refers to are
 * added to the concept index in the knowledge model by the CBRModel class
 * automatically and as such they can be referred to by code even though the
 * names of the actual model may have changed.
 *
 * This interface is deprecated, as IsoPodModel is deprecated. Use BasicModel
 * or CBRModel instead.
 *
 * This interface should be made static as soon as Java 1.5 is widespread.
 * </p>
 * @author Frode Srmo, small changes by Elise Bakke
 * @deprecated
 * @version 1.0
 */

public interface IsoPod
{
  public static final String CONCEPT = "_concept";

  public static final String RELATION = "_relation";
  public static final String INVERSE_RELATION ="_inverse relation";

  public static final String STRUCTURAL_RELATION = "_structural relation";
  public static final String INVERSE_STRUCTURAL_RELATION = "_inverse structural relation";
  public static final String SUBCLASS_OF = "_subclass of";
  public static final String HAS_SUBCLASS = "_has subclass";
  public static final String HAS_INSTANCE = "_has instance";
  public static final String INSTANCE_OF = "_instance of";
  public static final String HAS_PART = "_has part";
  public static final String PART_OF = "_part of";

  public static final String SYSTEM_RELATION = "_system relation";
  public static final String INVERSE_SYSTEM_RELATION = "_inverse system elation";
  public static final String TRANSFERS = "_transfers";
  public static final String INHERITS_OVER = "_inherits over";
  public static final String HAS_DEFAULT_EXPLANATION_STRENGTH = "_default explanation strength";
  public static final String DEFAULT_EXPLANATION_STRENGTH_OF ="_default explanation strength of";
  public static final String HAS_NATURAL_NAME = "_has natural name";
  public static final String NATURAL_NAME_OF = "_natural name of";
  public static final String HAS_INVERSE = "_has inverse";
  public static final String HAS_COMPARATOR = "_has comparator";
  public static final String COMPARATOR_OF ="_comparator of";
  public static final String HAS_CASE_STATUS = "_has case status";
  public static final String CASE_STATUS_OF = "_case status of";
  public static final String HAS_SOLUTION = "_has solution";
  public static final String SOLUTION_OF = "_solution of";
  public static final String HAS_VALUE_TYPE = "_has value type";
  public static final String VALUE_TYPE_OF = "_value type of";
  public static final String HAS_FROM_TYPE = "_has from type";
  public static final String FROM_TYPE_OF = "_from type of";

  public static final String FINDING_RELATION = "_finding relation";
  public static final String INVERSE_FINDING_RELATION = "_inverse finding relation";

  public static final String CAUSAL_RELATION = "_causal relation";
  public static final String INVERSE_CAUSAL_RELATION = "_inverse causal relation";
  public static final String CAUSES = "_causes";
  public static final String CAUSED_BY = "_caused by";
  public static final String IMPLIES = "_implies";
  public static final String IMPLIED_BY = "_implied by";

  public static final String ENTITY = "_entity";
  public static final String NO_VALUE = "_no value";
  public static final String NUMBER = "_number";
  public static final String CASE = "_case";
  public static final String SYMBOL = "_symbol";
  public static final String JAVA_CLASS = "_java class";

  public static final String CASE_STATUS = "_case_status";
  public static final String PROCESSED_CASE = "_processed case";
  public static final String SOLVED_CASE = "_solved case";
  public static final String UNSOLVED_CASE = "_unsolved case";

  public static final String NUMBER_COMPARISON = "_number comparison";
  public static final String CASE_COMPARISON = "_case comparison";
  public static final String SYMBOL_COMPARIOSON = "_symbol comparison";

  public static final String STRING = "_string";
  public static final String URL = "_url";
}
