package jcreek.representation.inference;

import jcreek.representation.*;

public class SubclassInheritanceMethod extends InheritanceMethod
{
  public SubclassInheritanceMethod()
  {
  }

  public boolean accept(Relation target)
  {
    return true;
  }

  public boolean accept(Relation from, Entity next)
  {
//    System.out.println("Testing accept for "+next.toString()+" (from "+from.toString()+")");
    RelationType rcd = from.getRelationType();

    if(from.getKnowledgeModel().getRelationType(BasicModel.SUBCLASS_OF).isAssignableFrom(rcd))
    {
//        System.out.println("Accepted");
        return true;
    }
    else
     return false;
  }

  public boolean accept(Explanation path)
  {
    return true;
  }

  public boolean acceptInheritance(Relation target)
  {
    RelationType rcd = target.getRelationType();

    if(target.getKnowledgeModel().getRelationType(BasicModel.SUBCLASS_OF).isAssignableFrom(rcd))
      return false;

    if(target.getKnowledgeModel().getRelationType(BasicModel.SUBCLASS_OF).getInverseType().isAssignableFrom(rcd))
      return false;

    if(target.getKnowledgeModel().getRelationType(BasicModel.HAS_INVERSE).getInverseType().isAssignableFrom(rcd))
      return false;

    return true;
  }

  public boolean reenter(Entity target)
  {
    return false;
  }
}

