package jcreek.representation.inference;

import jcreek.util.CreekException;

/**
 * Thrown when a task is too complex according to some measure. Used to control
 * NP-hard or tasks that can not be guaranteed to return in finite time.
 *
 * @author Frode Srmo
 * @version 1.0
 */

public class TaskTooComplexException extends CreekException
{
  int complexity;
  public TaskTooComplexException(String msg, int complexity)
  {
    super(msg);
    this.complexity = complexity;
  }

  public int getComplexity()
  {
    return complexity;
  }
}

