package jcreek.util.graph;

import java.util.EventObject;

/**
 * <p>Title: GraphChangeEvent</p>
 * <p>Description: Event object for events triggered in graph models (e.g. GraphModel)
 * @author Frode Srmo
 * @version 1.0
 */

public class GraphChangeEvent extends EventObject
{
  public static final int NODE_MOVED = 0;
  public static final int NODE_ADDED = 1;
  public static final int NODE_REMOVED = 2;
  public static final int NODE_CHANGED = 3;
  public static final int EDGE_ADDED = 4;
  public static final int EDGE_REMOVED = 5;
  public static final int EDGE_CHANGED = 6;

  private Node node;
  private Edge edge;
  private int type;

  public GraphChangeEvent(Node node, int type)
  {
    super(node);
    this.type = type;
  }

  public GraphChangeEvent(Edge edge, int type)
  {
    super(edge);
    this.type = type;
  }

  public int getType()
  {
    return type;
  }

  public Node getNode()
  {
    return (Node) getSource();
  }

  public Edge getEdge()
  {
    return (Edge) getSource();
  }
}