package jcreek.util.graph;

/**
 * <p>Title: GraphChangeEvent</p>
 * <p>Description: A class implementing this listener may register itself as
 * a change listener with the Graph to be notified whenever a change
 * occurs.</p>
 * @author Frode Srmo
 * @version 1.0
 */

public interface GraphChangeListener
{
  public void nodeMoved(GraphChangeEvent e);
  public void nodeChanged(GraphChangeEvent e);
  public void nodeAdded(GraphChangeEvent e);
  public void nodeRemoved(GraphChangeEvent e);
  public void edgeAdded(GraphChangeEvent e);
  public void edgeRemoved(GraphChangeEvent e);
  public void edgeChanged(GraphChangeEvent e);
}