package jcreek.util.graph.layout;

import java.awt.Rectangle;

import jcreek.util.graph.Graph;
import jcreek.util.graph.Node;

/**
 * This interface represents a particular method of laying out a graph of nodes
 * on a 2 dimensional surface.
 */

public interface Layout
{
  /**
   * Lay out the graph within the supplied bounds.
   */
  public void layout(Graph graph, Rectangle bounds);

  /**
   * Lay out the specified nodes of the graph within the supplied bounds.
   */
  public void layout(Graph graph, Node[] nodes, Rectangle bounds);
}