/*********************************************************************
 *
 * DESCRIPTION:
 *      This file defines the Test open action.
 ********************************************************************/

package jcreek.cke.command;

import jcreek.cke.browser.Visualizer;
import jcreek.cke.MainWindow;
import jcreek.cke.CreekDocumentGroup;
import jcreek.cke.conceptview.ConceptView;

import java.awt.event.ActionEvent;
import java.io.File;
import java.awt.FileDialog;
import java.io.IOException;
import java.util.Hashtable;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * Implements the open file action used to open an test
 * graph document.
 *
 * @author
 * @version
 */
public class OpenTestAction extends CreekAction implements PropertyChangeListener{

    /**
     * Creates a new OpenTestAction object with the default action
     * command string of "open".
     */
    public OpenTestAction() {
        super( "openTest" );
        setEnabled(true);
        CreekDocumentGroup.instanceOf().addPropertyChangeListener( this );
    } // OpenAction

    /**
     * Performs the open action. This presents the user with
     * a file selector and opens the selected file as a graph
     * document. Causes a new window to be opened.
     *
     * @param  event  action event
     */
    public void actionPerformed( ActionEvent event ) {
        Visualizer win = getWindow( event );//rem03/02
        // call save File to allow user to specify
        // the file to create the KnowledgeModel
        saveFile( getWindow( event ), false, false );
    } // actionPerformed

      public void propertyChange( PropertyChangeEvent e ) {
        if ( e.getPropertyName().equals( "opened" ) )
        {
            if(e.getNewValue()==null)
                  setEnabled(true);
            else
                  setEnabled(false);
        }
        else if(e.getPropertyName().equals( "closed" ))
            setEnabled(true);
  }


    protected boolean saveFile( Visualizer win,
                                boolean askUser,
                                boolean forceSaveAs )
    {
      CreekDocumentGroup.instanceOf().openTestKM();
      win.setTitle(MainWindow.instanceOf().getResourceString("AppTitle")
                      + " " +CreekDocumentGroup.instanceOf().getKM().getName());
        /* boolean okay = true;
        CreekDocumentGroup dg = CreekDocumentGroup.instanceOf();
            // get name and path for new file
            FileDialog fd = new FileDialog
                ( win,
		  getString( "newKMTitle" ),
		  FileDialog.SAVE );
            fd.show();
            if ( ( fd.getFile() != null ) ||
                 ( fd.getDirectory() != null ) ) {
                if ( ( okay = dg.openTestKM
                       ( fd.getFile(), fd.getDirectory() ) ) ) {
                    win.setTitle(MainWindow.instanceOf().getResourceString("AppTitle")
                      + " " +dg.getKM().getName());

                }
            }
        if ( !okay ) {
            JOptionPane.showMessageDialog
                ( win,
		  getString( "couldntSaveMsg" ),
                  getString( "operFailedTitle" ),
                  JOptionPane.ERROR_MESSAGE );
        } */
        return true;
    } // saveFile


} // OpenAction
